program SpectroDriver;
{a jour le 30/10/00 }
{MODIFICATIONS}
{27.03.01 : EL:modifications pour jumelage avec traitement:
               changement tdeuxdform en tGraph2DForm }
{%ToDo 'SpectroDriver.todo'}

uses
  buttons,
  Windows,
  SysUtils,
  Classes,
  Graphics,
  Forms,
  Controls,
  StdCtrls,
  MainForm in 'MainForm.pas' {principalform},
  dialogNewSpectrum in 'dialogNewSpectrum.pas' {enterDlg},
  editdata in 'editdata.pas' {dataeditform},
  VariablesListe in 'VariablesListe.pas' {VariablesListeForm},
  SuiviDesVariables in 'SuiviDesVariables.pas' {SuiviDesVariablesForm},
  functionsliste in 'functionsliste.pas' {functionslisteform},
  interfaceMoteurs in 'interfaceMoteurs.pas' {tabmot},
  editMoteursBase in 'editMoteursBase.pas' {editMoteursBaseForm},
  SuiviAcquisitionPRISM in 'SuiviAcquisitionPRISM.pas' {suiviPRISMform},
  setzerodialog in 'setzerodialog.pas' {setzeromoteursDlg},
  GPIB_CEC in 'GPIB_CEC.pas',
  BoiteNoire in 'BoiteNoire.pas' {boitnoir},
  Operations in 'Operations.pas' {operationform},
  editFenetresBaseParam in 'editFenetresBaseParam.pas' {editfenetreform},
  dialogdebut in 'dialogdebut.pas' {debutdlg},
  editFenetresBase in 'editFenetresBase.pas' {EditFenetresBaseForm},
  DafMTMX in 'DafMTMX.pas',
  AT_AOMIO in 'AT_AOMIO.pas',
  dialogAddSpectrum in 'dialogAddSpectrum.pas' {dialogaddform},
  comptage2DTOF in 'comptage2DTOF.pas' {comptage2DTOFform},
  EuroPSD in 'EuroPSD.pas',
  comptage2D in 'comptage2D.pas' {comptage2Dform},
  interpreteur in 'interpreteur.pas' {interpreteurform},
  CarteMicro in 'CarteMicro.pas',
  ITC4drv in 'ITC4drv.pas' {ITC4},
  ATSR200 in 'ATSR200.pas',
  BOSS508 in 'BOSS508.pas',
  visu_polarisation in 'visu_polarisation.pas' {visupol},
  PilotageRMN in 'PilotageRMN.pas' {PilotageRMNForm},
  ComptagePSDform in 'ComptagePSDform.pas' {ComptagePSD},
  Graph1D in 'Graph1D.pas' {graph1dform},
  graph2D in 'graph2D.pas' {graph2DForm},
  about in 'About.pas' {AboutBox};

{$R *.RES}

{ type numr pour faire rfrence  la polarisation  }
type polarisation=(up,down);

begin
  Application.Initialize;
  Application.CreateForm(Tprincipalform, principalform);
  Application.CreateForm(TEditFenetresBaseForm, EditFenetresBaseForm);
  Application.CreateForm(Tdebutdlg, debutdlg);
  Application.CreateForm(Teditfenetreform, editfenetreform);
  Application.CreateForm(TenterDlg, enterDlg);
  Application.CreateForm(Tgraph1dform, graph1dform);
  Application.CreateForm(Tgraph2DForm, graph2DForm);
  Application.CreateForm(TAboutBox, AboutBox);
  if debutdlg.showmodal=idOK then begin
{ ouverture des fenetres 1D }
  if debutdlg.tableexpf1.value=1 then Application.CreateForm(TGraph1Dform, Gr1D[1]);
  if debutdlg.tableexpf2.value=1 then begin
                                      Application.CreateForm(TGraph1Dform, Gr1D[2]);
{ on change la couleur pour difrnecier }  Gr1D[2].panel2.color:=clGreen;  end;
  if debutdlg.tableexpf3.value=1 then Application.CreateForm(TGraph1Dform, Gr1D[3]);
  if debutdlg.tableexpf4.value=1 then Application.CreateForm(TGraph1Dform, Gr1D[4]);
{ ouverture des fenetres 2D avec couleur}
  if debutdlg.tableexpf5.value=1 then begin
                                      Application.CreateForm(tgraph2Dform, Gr2D[1]);
                                      Gr2D[1].panel2.color:=clRed;  end;
  if debutdlg.tableexpf6.value=1 then begin
                                      Application.CreateForm(tgraph2Dform, Gr2D[2]);
                                      Gr2D[2].panel2.color:=clGreen;  end;
  if debutdlg.tableexpf7.value=1 then Application.CreateForm(tgraph2Dform, Gr2D[3]);
  if debutdlg.tableexpf8.value=1 then Application.CreateForm(tgraph2Dform, Gr2D[4]);
{ fenetres de gestion des moteurs }
  if debutdlg.tableexpf9.value=1 then
  begin
  Application.CreateForm(Ttabmot, tabmot);
  Application.CreateForm(Teditmoteursbaseform, editmoteursbaseform);
  Application.CreateForm(TsetzeromoteursDlg, setzeromoteursDlg);
  end;
{ fentres d'dition des data }
  if debutdlg.tableexpf10.value=1 then  begin Application.CreateForm(Tdataeditform, dataeditform);  end;
{ fentres lies a l'interprteur }
  if debutdlg.tableexpf11.value=1 then
  begin
  Application.CreateForm(Tinterpreteurform, interpreteurform);
  Application.CreateForm(TVariablesListeForm, VariablesListeForm);
  Application.CreateForm(TSuiviDesVariablesForm, SuiviDesVariablesForm);
  Application.CreateForm(Tfunctionslisteform, functionslisteform);
  end;
{ cration de la boite noire }
  if debutdlg.tableexpf12.value=1 then Application.CreateForm(Tboitnoir, boitnoir);
{ opration}
  if debutdlg.tableexpf14.value=1 then Application.CreateForm(Toperationform, operationform);
{ suivi de la temperature }
  if debutdlg.tableexpf15.value=1 then Application.CreateForm(Titc4, itc4);
  { ????????, !!!!!!!!! ????????????}
  gpibtype:=debutdlg.tableexpf13.value;
{ fentre de comptage simple avec PRISM ancienne version }
  if debutdlg.tableexpf20.value=1 then Application.CreateForm(TsuiviPRISMForm, suiviPRISMForm);
{ veut-on une fenetre de comptage 2D ?}
  if debutdlg.tableexpf21.value=1 then Application.CreateForm(TComptagePSD, comptagePSD);
 { fenetres d'acquisition PAPOL et RMN }
  if debutdlg.tableexpf25.value=1 then Application.CreateForm(Tcomptage2Dform, comptage2Dform);
  if debutdlg.tableexpf26.value=1 then Application.CreateForm(Tcomptage2DTOFform, comptage2DTOFform);
  if debutdlg.tableexpf28.value=1 then Application.CreateForm(TpilotageRMNForm, pilotageRMNForm);
  if debutdlg.tableexpf29.value=1 then Application.CreateForm(Tvisupol, visupol);

{  Application.CreateForm(Tacqfiform, acqfiform); }
  end;
{ rorganisation des fentres dans la configuration sauvegarde }
{ A DEBUGGER }
  principalform.reorganiser;
  Application.Run;
end.

