unit SuiviAcquisitionPRISM;
{cette unit gre le comptage simple
Elle reoit les ordres extrieurs
dmarrage d'un comptage qui s'effectue en fonction
des parametres typpolar,typcompt, tempstotal
et temps unitaires
le timer lit regulirement les donnes et le cas chant change le comptage
En cas de fin de comptage ou nbre de coups atteints,
il y a un transfert des donnes dpendant de l'existence
d'un multidtecteur ou non}
{ ========================== }
{ utilisation du multicompteur }
{ il faut passer "simple" de false  true }
{ et reectiver les lignes ou simple ou bien acqfiform apparait }
{ 02.02.01 : FO : augmentation de la prcision de l'affichage des angles }
{                 modifications de AcqSimple  A TESTER                   }
{ 07.02.01 : UR : string[80] --> string pour des data pour la boite noire}
{ 08.02.01 : UR : demontage d'un bug in facquis, option 14               }
{ 08.02.01 : FO : 2 secondes pause quand le polarisation change          }
{ 06.06.01 : FO : modif de la procedure "fixflip" pour qu'elle fonctionne }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, Spin,ExtCtrls, registry, GPIB_CEC, Menus, operations, BOSS508{, testacqfi};

const
sreg='\manips'; {?? }
addsimple=5;    {?? }
simple=true; { pour dire si on utilise un monocompteur ou un multicompteur }
type
  TsuiviPRISMform = class(TForm)
    strgd1: TStringGrid;
    strgd2: TStringGrid;
    Label1: TLabel;
    CountingTime: TSpinEdit;
    SpinStates: TComboBox;
    TypeOfCounting: TComboBox;
    Timer1: TTimer;
    MainMenu1: TMainMenu;
    simple1: TMenuItem;
    Timer2: TTimer;
    ToggleSpinStatesButton: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Acquisition2: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure SpinStatesChange(Sender: TObject);
    procedure TypeOfCountingChange(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure strgd2GetEditMask(Sender: TObject; ACol, ARow: Integer;
      var Value: String);
    procedure Timer1Timer(Sender: TObject);
    procedure simple1Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure ToggleSpinStatesButtonClick(Sender: TObject);
  private
  timer2typ:integer;
  typflip:integer;
  butflip:integer;
    { Dclarations prives }
  public
  regis:tregistry;
  procedure writeparam;
  procedure readparam;
  procedure acquisimple;
  procedure tfrechelle;
  procedure flip(i:integer);
  function facquis:boolean;
  procedure acqsimple(p1,p2,p3,p4:extended);
  function testacquis:boolean;
  procedure getcomptage(i:integer;var x,mon,tem:integer);
  function getpolar:string;
  procedure stop;
  procedure fixtemps(temp:integer);
  procedure fixpolar(polar:string);
  procedure fixcompt(comp:string);
  procedure fixflip(comp:string);
  procedure comptcond(index:integer;valeur:integer);
  end;

{ quelques variables globales vitales }
{ il serait agrable d'en diminuer le nombre }
var
  suiviPRISMform: TsuiviPRISMform;     {??}
  typpolar:integer;  { polarisations considres dans un comptage }
  typcompt:integer;  { type de comptage: temps ou mixte          }
  tempstotal:integer;{ temps total de comptage                   }
  tu:array[1..4] of integer;         { ?? }
  cl:array[1..4] of integer;         { ?? }
  actu:array[1..4,1..3] of integer;  { ?? }
  valeur:array[1..12] of integer;    { ?? }
  valeur1:array[1..12] of integer;   { ?? }
  acquison:integer;                  { ?? }
  combinup:integer;                  { ?? }
  alter:integer;                     { ?? }
  acquiscour:integer;                { ?? }
  tempsboucle:integer;               { ?? }
  sdevant:string;                    { ?? }

implementation

{ pourquoi est-ce spar des autres clauses uses ??}
uses boiteNoire, InterfaceMoteurs;

{$R *.DFM}

{ initialisation de la grille de comptage en neutrons polariss }
{ remplissage des noms des colonnes et lignes                   }
{ + srie d'autres initialisations  prciser                   }
procedure TsuiviPRISMform.FormCreate(Sender: TObject);
var
i,j:integer;
begin
strgd1.cells[0,1]:='N';
strgd1.cells[0,2]:='M';
strgd1.cells[0,3]:='T';
strgd2.cells[0,0]:='Tu';
strgd2.cells[0,1]:='Cl';
strgd1.cells[1,0]:='  R++';
strgd1.cells[2,0]:='  R--';
strgd1.cells[3,0]:='  R+-';
strgd1.cells[4,0]:='  R-+';
for i:=1 to 4 do
for j:=1 to 3 do
strgd1.cells[i,j]:='00000000';
for i:=1 to 4 do begin
strgd2.cells[i,0]:='00000020';
strgd2.cells[i,1]:='00001000';
end;
regis:=tregistry.create;
regis.openkey(sreg,true);
if regis.valueexists('Tu1') then
tu[1]:=regis.readinteger('Tu1')
else begin tu[1]:=5;regis.writeinteger('Tu1',tu[1]);end;
if regis.valueexists('Tu2') then
tu[2]:=regis.readinteger('Tu2')
else begin tu[2]:=5;regis.writeinteger('Tu2',tu[2]);end;
if regis.valueexists('Tu3') then
tu[3]:=regis.readinteger('Tu3')
else begin tu[3]:=5;regis.writeinteger('Tu3',tu[3]);end;
if regis.valueexists('Tu4') then
tu[4]:=regis.readinteger('Tu4')
else begin tu[4]:=5;regis.writeinteger('Tu4',tu[4]);end;
if regis.valueexists('Cl1') then
Cl[1]:=regis.readinteger('Cl1')
else begin Cl[1]:=5;regis.writeinteger('Cl1',Cl[1]);end;
if regis.valueexists('Cl2') then
Cl[2]:=regis.readinteger('Cl2')
else begin Cl[2]:=5;regis.writeinteger('Cl2',Cl[2]);end;
if regis.valueexists('Cl3') then
Cl[3]:=regis.readinteger('Cl3')
else begin Cl[3]:=5;regis.writeinteger('Cl3',Cl[3]);end;
if regis.valueexists('Cl4') then
Cl[4]:=regis.readinteger('Cl4')
else begin Cl[4]:=5;regis.writeinteger('Cl4',Cl[4]);end;
if regis.valueexists('Temps') then
Tempstotal:=regis.readinteger('Temps')
else begin Tempstotal:=20;
regis.writeinteger('Temps',Tempstotal);end;
if regis.valueexists('polarisation') then
typpolar:=regis.readinteger('polarisation')
else begin typpolar:=0;
regis.writeinteger('polarisation',typpolar);end;
if regis.valueexists('Comptage') then
typpolar:=regis.readinteger('Comptage')
else begin typcompt:=0;
regis.writeinteger('Comptage',typcompt);end;
writeparam;
acquison:=0;
combinup:=0;
alter:=0;
acquiscour:=0;
tempsboucle:=0;
sdevant:='';  { ?? }
top:=350;
left:=0;
typflip:=0;
butflip:=0;
end;

{ procedure de lecture du comptage          }
{ INPUT: i, ???                             }
{        implicite!!, valeur1 ???           }
{ OUTPUT: x, nbr de neutrons                }
{         mon, moniteur                     }
{         tem, temps de comptage ?          }
procedure TsuiviPRISMform.getcomptage(i:integer;var x,mon,tem:integer);
begin
if (i>=1) and (i<=4) then begin
x:=valeur1[1+(i-1)*3];
mon:=valeur1[2+(i-1)*3];
tem:=valeur1[3+(i-1)*3];
end;
end;

{ retourne les tats de polarisation mesurs }
{ INPUT: implicite: tat de la combo "spin-state" }
{ OUTPUT: une chane de caractre contenant les tats de spin demands ou }
{         mesurs                                                         }
function TsuiviPRISMform.getpolar:string;
begin
result:=spinStates.text;
end;

{ ???}
{ beaucoup d'entres implicites !!! }
procedure TsuiviPRISMform.writeparam;
var
i:integer;
begin
spinStates.itemindex:=typpolar;
typeOfCounting.itemindex:=typcompt;
countingTime.value:=tempstotal;
for i:=1 to 4 do begin
strgd2.cells[i,0]:=inttostr(tu[i]);
strgd2.cells[i,1]:=inttostr(cl[i]);
end;
end;

{ ???}
{ beaucoup d'entres implicites !!! }
procedure TsuiviPRISMform.readparam;
var
i:integer;
begin
typpolar:=spinStates.itemindex;
typcompt:=typeOfCounting.itemindex;
tempstotal:=CountingTime.value;
for i:=1 to 4 do begin
tu[i]:=strtoint(strgd2.cells[i,0]);
cl[i]:=strtoint(strgd2.cells[i,1]);
end;
regis.writeinteger('Tu1',tu[1]);
regis.writeinteger('Tu2',tu[2]);
regis.writeinteger('Tu3',tu[3]);
regis.writeinteger('Tu4',tu[4]);
regis.writeinteger('cl1',cl[1]);
regis.writeinteger('cl2',cl[2]);
regis.writeinteger('cl3',cl[3]);
regis.writeinteger('cl4',cl[4]);
regis.writeinteger('polarisation',typpolar);
regis.writeinteger('Temps',Tempstotal);
regis.writeinteger('Comptage',typcompt);
end;

{ changement des tats de spin considrs }
{ OUTPUT: typpolar est mis  jour         }
{         regis est mis a jour ??         }
procedure TsuiviPRISMform.SpinStatesChange(Sender: TObject);
begin
typpolar:=spinStates.itemindex;
regis.writeinteger('polarisation',typpolar);
end;

{ changement du type de comptage                        }
{ OUTPUT: typcompt est mis  jour (temps ou mixte)      }
{         regis est mis a jour ??                       }
procedure TsuiviPRISMform.TypeOfCountingChange(Sender: TObject);
begin
typcompt:=typeOfCounting.itemindex;
regis.writeinteger('Comptage',typcompt);
end;

{ changement du temps de comptage                         }
{ OUTPUT: tempstotal est mis  jour (temps ou mixte)      }
{         regis est mis a jour ??                         }
procedure TsuiviPRISMform.SpinEdit1Change(Sender: TObject);
begin
tempstotal:=CountingTime.value;
regis.writeinteger('Temps',Tempstotal);
end;

{ ???}
{ beaucoup d'entres implicites !!! }
procedure TsuiviPRISMform.strgd2GetEditMask(Sender: TObject; ACol, ARow: Integer;
  var Value: String);
begin
value:='########';
end;

{ ??? }
procedure TsuiviPRISMform.Timer1Timer(Sender: TObject);
var
s:string;
begin
if acquison=1 then begin
tempsboucle:=(tempsboucle +1) mod 5;
if tempsboucle=0 then tfrechelle;
s:='F';gpibsend(addsimple,s);gpibread(addsimple,s,255);
if s<>'00' then begin
acquison:=0;facquis;end;
end;
end;

{ lancement des comptages                                 }
{ INPUT: implicite
{            type de comptage lu dans la combobox correspondante }
{            plutt que d'utiliser "typcom" ??                   }
{ OUTPUT: ???                                                    }
procedure tsuiviPRISMform.acquisimple;
var
s:string;
st: array[1..4] of string[10];
i:integer;
tfdir:boolean;
begin
readparam;    { ?? }
for i:=1 to 12 do valeur[i]:=0; { ?? }
acquiscour:=1;
acquison:=1;
s:=inttostr(tempstotal)+'00';
for i:=1 to 4 do
st[i]:=inttostr(tu[i])+'00';
if (spinStates.itemindex<=3) and (tempstotal<60) then
tfdir:=true else tfdir:=false;
   case spinStates.itemindex of
{++} 0:begin
     flip(0);
     if tfdir then gpibsend(addsimple,'T'+s)
     else gpibsend(addsimple,'T'+st[1]);
     combinup:=0;
     end;
{--} 1:begin
     flip(1);
     if tfdir then gpibsend(addsimple,'T'+s)
     else gpibsend(addsimple,'T'+st[2]);
     combinup:=0;
     end;
{+-} 2:begin
     flip(2);
     if tfdir then gpibsend(addsimple,'T'+s)
     else gpibsend(addsimple,'T'+st[3]);
     combinup:=0;
     end;
{-+} 3:begin
     flip(3);
     if tfdir then gpibsend(addsimple,'T'+s)
     else gpibsend(addsimple,'T'+st[3]);
     combinup:=0;
     end;
     4:begin {++  --}
     if alter=0 then combinup:=1;
     alter:=1;combinup:=(combinup+1) mod 2;
     if (combinup=0) then begin
     flip(0);gpibsend(addsimple,'T'+st[1]);end;
     if (combinup=1) then begin
     flip(1);gpibsend(addsimple,'T'+st[2]);end;
     end;
   5:begin {++  +-}
     if alter=0 then combinup:=1;
     alter:=1;combinup:=(combinup+1) mod 2;
     if (combinup=0) then begin
     flip(0);gpibsend(addsimple,'T'+st[1]);end;
     if (combinup=1) then begin
     flip(2);gpibsend(addsimple,'T'+st[3]);end;
     end;
   6:begin {++  -+}
     if alter=0 then combinup:=1;
     alter:=1;combinup:=(combinup+1) mod 2;
     if (combinup=0) then begin
     flip(0);gpibsend(addsimple,'T'+st[1]);end;
     if (combinup=1) then begin
     flip(3);gpibsend(addsimple,'T'+st[4]);end;
     end;
   7:begin {-- +-}
     if alter=0 then combinup:=1;
     alter:=1;combinup:=(combinup+1) mod 2;
     if (combinup=0) then begin
     flip(1);gpibsend(addsimple,'T'+st[2]);end;
     if (combinup=1) then begin
     flip(2);gpibsend(addsimple,'T'+st[3]);end;
     end;
   8:begin  {-- -+}
     if alter=0 then combinup:=1;
     alter:=1;combinup:=(combinup+1) mod 2;
     if (combinup=0) then begin
     flip(1);gpibsend(addsimple,'T'+st[2]);end;
     if (combinup=1) then begin
     flip(3);gpibsend(addsimple,'T'+st[4]);end;
     end;
   9:begin  {+- -+}
     if alter=0 then combinup:=1;
     alter:=1;combinup:=(combinup+1) mod 2;
     if (combinup=0) then begin
     flip(2);gpibsend(addsimple,'T'+st[3]);end;
     if (combinup=1) then begin
     flip(3);gpibsend(addsimple,'T'+st[4]);end;
     end;
   10:begin  {++ -- +-}
     if alter=0 then combinup:=-1;
     alter:=1;combinup:=(combinup+1) mod 3;
     if (combinup=0) then begin
     flip(0);gpibsend(addsimple,'T'+st[1]);end;
     if (combinup=1) then begin
     flip(1);gpibsend(addsimple,'T'+st[2]);end;
     if (combinup=2) then begin
     flip(2);gpibsend(addsimple,'T'+st[3]);end;
     end;
   11:begin {++ -- -+}
     if alter=0 then combinup:=-1;
     alter:=1;combinup:=(combinup+1) mod 3;
     if (combinup=0) then begin
     flip(0);gpibsend(addsimple,'T'+st[1]);end;
     if (combinup=1) then begin
     flip(1);gpibsend(addsimple,'T'+st[2]);end;
     if (combinup=2) then begin
     flip(3);gpibsend(addsimple,'T'+st[4]);end;
     end;
   12:begin {++ +- -+}
     if alter=0 then combinup:=-1;
     alter:=1;combinup:=(combinup+1) mod 3;
     if (combinup=0) then begin
     flip(0);gpibsend(addsimple,'T'+st[1]);end;
     if (combinup=1) then begin
     flip(2);gpibsend(addsimple,'T'+st[3]);end;
     if (combinup=2) then begin
     flip(3);gpibsend(addsimple,'T'+st[4]);end;
     end;
   13:begin {-- +- -+}
     if alter=0 then combinup:=-1;
     alter:=1;combinup:=(combinup+1) mod 3;
     if (combinup=0) then begin
     flip(1);gpibsend(addsimple,'T'+st[2]);end;
     if (combinup=1) then begin
     flip(2);gpibsend(addsimple,'T'+st[3]);end;
     if (combinup=2) then begin
     flip(3);gpibsend(addsimple,'T'+st[4]);end;
     end;
   14:begin {++ -- +- -+}
     if alter=0 then combinup:=-1;
     alter:=1;combinup:=(combinup+1) mod 4;
     if (combinup=0) then begin
     flip(0);gpibsend(addsimple,'T'+st[1]);end;
     if (combinup=1) then begin
     flip(1);gpibsend(addsimple,'T'+st[2]);end;
     if (combinup=2) then begin
     flip(2);gpibsend(addsimple,'T'+st[3]);end;
     if (combinup=3) then begin
     flip(3);gpibsend(addsimple,'T'+st[4]);end;
     end;
  end;
  { appel MULTICOMPTEUR }
{ ****  if simple=false then acqfiform.acquidirect; { appel spcifique  l'utilisation du muulticompteur }
  end;

{ ?? }
procedure tsuiviPRISMform.tfrechelle;
var
s:string;
i:integer;
err:integer;
begin
gpibsend(addsimple,'P');gpibread(addsimple,s,255);
val(s,valeur[2],err);
if simple then begin
 gpibsend(addsimple,'+1');gpibread(addsimple,s,255);
val(s,valeur[1],err);
end {else valeur[1]:=somfen; };
gpibsend(addsimple,'H');gpibread(addsimple,s,255);
val(s,valeur[3],err);
for i:=1 to 3 do
strgd1.Cells[typflip+1,i]:=formatfloat('00000000',valeur[i]+valeur1[(typflip)*3+i]);
{case combobox1.itemindex of
0..3:for i:=1 to 3 do
strgd1.Cells[combobox1.itemindex+1,i]:=formatfloat('00000000',valeur[i]);
4:for i:=1 to 3 do
strgd1.Cells[combinup+1,i]:=formatfloat('00000000',valeur[i]+valeur1[combinup*3+i]);
5:for i:=1 to 3 do
strgd1.Cells[2*combinup+1,i]:=formatfloat('00000000',valeur[i]+valeur1[combinup*6+i]);
6:for i:=1 to 3 do
strgd1.Cells[3*combinup+1,i]:=formatfloat('00000000',valeur[i]+valeur1[combinup*9+i]);
7:for i:=1 to 3 do
strgd1.Cells[combinup+2,i]:=formatfloat('00000000',valeur[i]+valeur1[combinup*3+i+6]);
8:for i:=1 to 3 do
strgd1.Cells[combinup+2,i]:=formatfloat('00000000',valeur[i]+valeur1[combinup*3+i+6]);
9:for i:=1 to 3 do
strgd1.Cells[combinup+2,i]:=formatfloat('00000000',valeur[i]+valeur1[combinup*3+i+6]);
10:begin
if combinup=0 then for i:=1 to 3 do
strgd1.Cells[1,i]:=formatfloat('00000000',valeur[i]+valeur1[i]);
if combinup=1 then for i:=1 to 3 do
strgd1.Cells[2,i]:=formatfloat('00000000',valeur[i]+valeur1[i+3]);
if combinup=2 then for i:=1 to 3 do
strgd1.Cells[4,i]:=formatfloat('00000000',valeur[i]+valeur1[i+9]);
end;
11:begin
if combinup=0 then for i:=1 to 3 do
strgd1.Cells[1,i]:=formatfloat('00000000',valeur[i]+valeur1[i]);
if combinup=1 then for i:=1 to 3 do
strgd1.Cells[3,i]:=formatfloat('00000000',valeur[i]+valeur1[i+6]);
if combinup=2 then for i:=1 to 3 do
strgd1.Cells[4,i]:=formatfloat('00000000',valeur[i]+valeur1[i+9]);
end;
12:for i:=1 to 3 do
strgd1.Cells[combinup+1,i]:=formatfloat('00000000',valeur[i]+valeur1[combinup*3+i]);
end;}
end;

{ ?? compltement obscur}
function tsuiviPRISMform.facquis:boolean;
var
total:longint;
s,s1:string;
tf:boolean;
i:integer;
temperature:real;
begin
readparam;
tfrechelle;
for i:=1 to 3 do
valeur1[(typflip)*3+i]:=valeur[i]+valeur1[typflip*3+i];
{acqfiform.addmulti(typflip); }
{
case combobox1.itemindex of
0..3:for i:=1 to 3 do valeur1[i+combobox1.itemindex*3]:=valeur[i]+valeur1[i+combobox1.itemindex*3];
4:for i:=1 to 3 do valeur1[i+combinup*3]:=valeur[i]+valeur1[i+combinup*3];
5:for i:=1 to 3 do valeur1[i+combinup*6]:=valeur[i]+valeur1[i+combinup*6];
6:for i:=1 to 3 do valeur1[i+combinup*9]:=valeur[i]+valeur1[i+combinup*9];
7:for i:=1 to 3 do valeur1[6+i+combinup*3]:=valeur[i]+valeur1[6+i+combinup*3];
8:for i:=1 to 3 do valeur1[i+combinup*3]:=valeur[i]+valeur1[i+combinup*3];
9:begin
if combinup<2 then
for i:=1 to 3 do valeur1[i+combinup*3]:=valeur[i]+valeur1[i+combinup*3]
else for i:=1 to 3 do valeur1[i+9]:=valeur[i]+valeur1[i+9];
end;
10:begin
if combinup=0 then
for i:=1 to 3 do valeur1[i]:=valeur[i]+valeur1[i]
else
for i:=1 to 3 do valeur1[i+3+combinup*3]:=valeur[i]+valeur1[i+3+combinup*3];
end;
11:for i:=1 to 3 do valeur1[i+combinup*3]:=valeur[i]+valeur1[i+combinup*3];
end;}
tf:=true;
total:=valeur1[3]+valeur1[6]+valeur1[9]+valeur1[12];
case typcompt of
0:begin
 if total<CountingTime.value*100 then tf:=false;
end;
1:begin
 if total<CountingTime.value*100 then
 begin tf:=false;
 case typpolar of
 0: if (valeur1[1]>cl[1]) then tf:=true;
 1: if (valeur1[4]>cl[2]) then tf:=true;
 2: if (valeur1[7]>cl[3]) then tf:=true;
 3: if (valeur1[10]>cl[4]) then tf:=true;
 4: begin
  if (valeur1[1]>cl[1]) then
  begin
   if (valeur1[4]>cl[2]) then tf:=true else
   if combinup=1 then combinup:=0;
  end else
   if (valeur1[4]>cl[2]) and (combinup=0) then combinup:=1;
 end;
 5:begin
  if (valeur1[1]>cl[1]) then
  begin
   if (valeur1[7]>cl[3]) then tf:=true else
   if combinup=1 then combinup:=0;
  end else
   if (valeur1[7]>cl[3]) and (combinup=0) then combinup:=1;
 end;
 6:begin
  if (valeur1[1]>cl[1]) then
  begin
   if (valeur1[10]>cl[4]) then tf:=true else
   if combinup=1 then combinup:=0;
  end else
   if (valeur1[10]>cl[4]) and (combinup=0) then combinup:=1;
 end;
 7:begin
  if (valeur1[4]>cl[2]) then
  begin
   if (valeur1[7]>cl[3]) then tf:=true else
   if combinup=1 then combinup:=0;
  end else
   if (valeur1[7]>cl[3]) and (combinup=0) then combinup:=1;
 end;
 8:begin
  if (valeur1[4]>cl[2]) then
  begin
   if (valeur1[10]>cl[4]) then tf:=true else
   if combinup=1 then combinup:=0;
  end else
   if (valeur1[10]>cl[4]) and (combinup=0) then combinup:=1;
 end;
  9:begin
  if (valeur1[7]>cl[3]) then
  begin
   if (valeur1[10]>cl[4]) then tf:=true else
   if combinup=1 then combinup:=0;
  end else
   if (valeur1[10]>cl[4]) and (combinup=0) then combinup:=1;
 end;
 10:if (valeur1[1]>cl[1]) and (valeur1[4]>cl[2])
 and (valeur1[7]>cl[3]) then tf:=true else begin
 if (valeur1[1]>cl[1]) and (combinup=2) then combinup:=0;
 if (valeur1[4]>cl[2]) and (combinup=0) then combinup:=1;
 if (valeur1[7]>cl[3]) and (combinup=1) then combinup:=2;
 if (valeur1[1]>cl[1]) and (combinup=2) then combinup:=0;
 end;
 11: if (valeur1[1]>cl[1]) and (valeur1[4]>cl[2])
 and (valeur1[10]>cl[4]) then tf:=true else begin
 if (valeur1[1]>cl[1]) and (combinup=2) then combinup:=0;
 if (valeur1[4]>cl[2]) and (combinup=0) then combinup:=1;
 if (valeur1[10]>cl[4]) and (combinup=1) then combinup:=2;
 if (valeur1[1]>cl[1]) and (combinup=2) then combinup:=0;
 end;
 12: if (valeur1[1]>cl[1]) and (valeur1[7]>cl[3])
 and (valeur1[10]>cl[4]) then tf:=true else begin
 if (valeur1[1]>cl[1]) and (combinup=2) then combinup:=0;
 if (valeur1[7]>cl[3]) and (combinup=0) then combinup:=1;
 if (valeur1[10]>cl[4]) and (combinup=1) then combinup:=2;
 if (valeur1[1]>cl[1]) and (combinup=2) then combinup:=0;
 end;
 13: if (valeur1[4]>cl[2]) and (valeur1[7]>cl[3])
 and (valeur1[10]>cl[4]) then tf:=true else begin
 if (valeur1[4]>cl[2]) and (combinup=2) then combinup:=0;
 if (valeur1[7]>cl[3]) and (combinup=0) then combinup:=1;
 if (valeur1[10]>cl[4]) and (combinup=1) then combinup:=2;
 if (valeur1[4]>cl[2]) and (combinup=2) then combinup:=0;
 end;

 14: if (valeur1[1]>=cl[1]) and (valeur1[4]>=cl[2])
 and (valeur1[10]>=cl[4]) and (valeur1[7]>=cl[3])
 then tf:=true else begin
 if (valeur1[1]>cl[1]) and (combinup=3) then combinup:=0;
 if (valeur1[4]>cl[2]) and (combinup=0) then combinup:=1;
 if (valeur1[7]>cl[3]) and (combinup=1) then combinup:=2;
 if (valeur1[10]>cl[4]) and (combinup=2) then combinup:=3;
 if (valeur1[1]>cl[1]) and (combinup=3) then combinup:=0;
 if (valeur1[4]>cl[2]) and (combinup=0) then combinup:=1;
 if (valeur1[7]>cl[3]) and (combinup=1) then combinup:=2;
 end;
 end;
 end;
end;
end;
if tf then begin
{ texte sauvegard dans la boite noire }
 s:=sdevant+chr(9);
 str(valeur1[1],s1);s:=s+s1+chr(9);str(valeur1[2],s1);s:=s+s1+chr(9);
 str(valeur1[4],s1);s:=s+s1+chr(9);str(valeur1[5],s1);s:=s+s1+chr(9);
 str(valeur1[7],s1);s:=s+s1+chr(9);str(valeur1[8],s1);s:=s+s1+chr(9);
 str(valeur1[10],s1);s:=s+s1+chr(9);str(valeur1[11],s1);s:=s+s1+chr(9);
 str(total,s1);s:=s+s1+chr(9);
{ lecture de la temprature }
{temperature:=OperationForm.ReadTemperatureRegul;
str(temperature:6:2,s1);s:=s+s1+chr(9); }
{ sauvegarde des points dans la boite noire }
 boitnoir.receivetext(s);
end;
facquis:=tf;
if not tf then acquisimple;
if tf then begin acquison:=0;acquiscour:=0;end;
end;

{ changement des tats des flippers }
{ INPUT: 0<i<3 : 0='up-up', 0='up-up', 0='up-up', 0='up-up' }
{ OUTPUT: les flippers sont switchs en fonction de l'tat de polarisation demand }
{ what is typflip ???}
procedure tsuiviPRISMform.flip(i:integer);
var
t:tdatetime;
toto:integer;
t0,t1:real;
begin
{flippers}
case i of
0:begin
{ gpibsend(6,'volt 0'+chr(10)); }
operationform.flipper1_on;
operationform.flipper2_off;
ToggleSpinStatesButton.caption:='up up';end;{up up}
1:begin
operationform.flipper1_off;
operationform.flipper2_on;
{ gpibsend(6,'volt 35'+chr(10));   }
ToggleSpinStatesButton.caption:='do do'; end;{do do}
2:begin
operationform.flipper1_on;
operationform.flipper2_on;
{ gpibsend(6,'volt 0'+chr(10)); }
ToggleSpinStatesButton.caption:='up do'; end;{up do}
3:begin
operationform.flipper1_off;
operationform.flipper2_off;
{gpibsend(6,'volt -35'+chr(10)); }
ToggleSpinStatesButton.caption:='do up'; end;{do up}
end;
{ cette partie de pause n'a pas l'air de marcher }
{if i<>typflip then begin
{t:=time;               { delay de 2s AVANT de flipper les alim ??? = dbile }
{ while (time<(t+2E-5)) and (time>t) do; }
{ end; }
{ cette pause doit passer minuit et traiter les messages windows }
{ elle peut durer trs longtemps                                 }
if i<>typflip then
begin
    t0:=(time-int(time))*86400;  {temps en s}
    repeat
      t1:=(time-int(time))*86400;
      if t1<t0 then t1:=t1+86400;  {correction bug passage par minuit}
{      Application.processMessages; }
    until ((t1-t0)>2); { on attend 2 secondes }
end;
typflip:=i;
end;

{ ???? }
procedure TsuiviPRISMform.simple1Click(Sender: TObject);
var
i:integer;
begin
for i:=1 to 12 do valeur1[i]:=0;
combinup:=0;alter:=0;
sdevant:='Simple';
{acqfiform.clearmulti; }
acquisimple;
end;

{ ???? 100% sotrique }
{ INPUT: p1, p2, p3, p4 }
{ OUTPUT: ??????        }
procedure TsuiviPRISMform.acqsimple(p1,p2,p3,p4:extended);
var
i,j:integer;
begin
for i:=1 to 12 do valeur1[i]:=0;
for i:=1 to 3 do
for j:=1 to 4 do strgd1.Cells[j,i]:=formatfloat('00000000',0);
combinup:=0;alter:=0;
i:=round(p1);
{acqfiform.clearmulti;}
case i of
0:sdevant:='Simple';
1:sdevant:='S '+chr(9)+floattostrf(p2,fffixed,5,7);
2:sdevant:='S '+chr(9)+floattostrf(p2,fffixed,5,7)+chr(9)+floattostrf(p3,fffixed,5,7);
3:sdevant:='S '+chr(9)+floattostrf(p2,fffixed,5,7)+chr(9)+
floattostrf(p3,fffixed,5,7)+chr(9)+floattostrf(p4,fffixed,5,7);
end;
acquiscour:=1;timer2typ:=0;timer2.enabled:=true;;
end;

{ ??? }
function TsuiviPRISMform.testacquis:boolean;
begin
if acquiscour>0 then result:=true else result:=false;
end;

{ ??? }
procedure TsuiviPRISMform.Timer2Timer(Sender: TObject);
begin
if not tabmot.onmov then
   begin
   timer2.enabled:=false;
   if timer2typ=0 then begin
                       acquisimple;
                       end;
   end;
end;

{ ??? }
procedure TsuiviPRISMform.stop;
begin
gpibsend(addsimple,'B');
acquison:=0;acquiscour:=0;combinup:=0;alter:=0;
end;

{ toggle manuel  entre les diffrents tats des flippers }
{ INPUT: 0<i<3 : 0='up-up', 0='up-up', 0='up-up', 0='up-up' }
{ OUTPUT: les flippers sont switchs en fonction de l'tat de polarisation demand }
{ typflip n'est pas modifi ???}
procedure TsuiviPRISMform.ToggleSpinStatesButtonClick(Sender: TObject);
begin
butflip:=(butflip+1) mod 4;
case butflip of
0:begin operationform.flipper1_on;
operationform.flipper2_off;ToggleSpinStatesButton.caption:='up up';end;{up up}
1:begin operationform.flipper1_off;
operationform.flipper2_on;ToggleSpinStatesButton.caption:='do do'; end;{do do}
2:begin operationform.flipper1_on;
operationform.flipper2_on;ToggleSpinStatesButton.caption:='up do'; end;{up do}
3:begin operationform.flipper1_off;
operationform.flipper2_off;ToggleSpinStatesButton.caption:='do up'; end;{do up}
end;
end;

{ ??? }
procedure TsuiviPRISMform.fixtemps(temp:integer);
begin
tempstotal:=temp;
CountingTime.value:=temp;
regis.writeinteger('Temps',Tempstotal);
end;

{ ??? }
procedure TsuiviPRISMform.fixpolar(polar:string);
begin
if SpinStates.items.indexof(polar)>=0 then begin
SpinStates.itemindex:=SpinStates.items.indexof(polar);
typpolar:=SpinStates.itemindex;
regis.writeinteger('polarisation',typpolar);
end;
end;

{ ??? }
procedure TsuiviPRISMform.fixcompt(comp:string);
begin
if SpinStates.items.indexof(comp)>=0 then begin
SpinStates.itemindex:=SpinStates.items.indexof(comp);
typpolar:=SpinStates.itemindex;
regis.writeinteger('Comptage',typcompt);
end;
end;

{ ??? }
{ INUTILE ??? }
procedure TsuiviPRISMform.fixflip(comp:string);
var
s:string;
begin
s:=uppercase(comp);
if comp='UPUP' then begin
                    flip(0);
                    spinStates.text:='Simple ++';
                    spinStates.update;
                    fixpolar('Simple ++');
                    end;
if comp='DODO' then begin
                    flip(1);
                    spinStates.text:='Simple --';
                    spinStates.update;
                    fixpolar('Simple --');
                    end;
if comp='UPDO' then begin
                    flip(2);
                    spinStates.text:='Simple +-';
                    spinStates.update;
                    fixpolar('Simple +-');
                    end;
if comp='DOUP' then begin
                    flip(3);
                    spinStates.text:='Simple -+';
                    spinStates.update;
                    fixpolar('Simple -+');
                    end;
end;

{ ??? }
procedure TsuiviPRISMform.comptcond(index:integer;valeur:integer);
begin
strgd2.cells[1+(index mod 4) ,index div 4]:=inttostr(valeur);
readparam;
end;

end.
