unit interpreteur;

{$DEFINE PILOTAGE }
{ $DEFINE TRAITEMENT }

{ jour le 30/10/00}
{ 17/11/00 (E.Leymarie) ajout de fonctions pour le comptage deux D et la RMN :
- delay[t] : pause de t seconde dans l'excution du batch
- acqsimple2D[TT, "wait"] : dmarre une acquisition neutron 2D de TT secondes. Si le deuxime champs est wait, l'interpreteur attend la fin de l'acquisition avant de passer  la ligne suivante.
- testacqsimple2D : test la fin de l'acquisition acqsimple2D. la variable acq2d de l'interpreteur est initialise  1 si l'acquisition est encore en cours et  0 si elle est termine.
- RMNsaturation[t] : dmarre une saturation de t ms. L'interpreteur est bloqu pendant la saturation.
- RMNlitpolar[npassages] : lit la polarisation nuclaire en npassages. Place le rsultat dans les variables temps et polar de l'interpreteur.
- RMNavecBase["true"] : permet de faire des spectres RMN avec ou sans signal de base.
- Addpol[x,y] : ajoute un point dont les coordonnes sont les variables x et y de l'interpreteur dans la fentre visupol.
- Clearvisupol : permet de rinitialiser visupol
Modification de interpreteurform.Timer1Timer pour arrter l'interpreteur pendant une acquisition 2d ou RMN
Ajout de nouvelles variables dans l'interpreteur :
	Variables RMN (si pilotageRMN existe) : polar et temps.
	Variable acquisition 2D (si comptage2D existe) : acq2d. }
{ 13.12.00 : FO : ajout d'une procdure lecture spectre, ligne 192 }
{              ReadSpectre1D et ReadSpectre2D                      }
{              nouvelle procdure AcqSimplePSD                     }
{              nouveau flag FlagWaitAcquisPSD                      }
{ 10.01.01 : FO : procedure pour fixer le courant dans la BOSS508        }
{              il manque une initialisation qqe part                     }
{              la BOSS n'accepte pas une rafale de commandes             }
{ 26.01.01 : FO : setFieldL, pilotage de la bobine supra                 }
{ 02.02.01 : FO : fonctionnement du bouton "continue" corrig A TESTER !!! }
{ 15.02.01 : FO : ajout d'une directive de compilation pour qu'on puisse utiliser traitement sans trainer toutes les units du programme de pilotage }
{               $DEFINE PILOTAGE                     }
{               $DEFINE TRAITEMENT                   }
{ 14.03.01 : FO : ajout de quelques fonctions de base Scal2D, Add2D, Sub2D                        }
{                 delSpectre2D, saveToASCII2D          }
{ 15.03.01 : CL :ajout des autres fonctions de base MultSpect, DivSpect, ScalAddSpect, }
{               ScalSubSpect, ScalMultSpect,ScalDivSpect }
{ 27.03.01 : EL :Modifications suite au couplage Traitement/pilotage:
                L 297: ajout du 3eme parametre a addspectre,
                L 323: idem pour addpt,
                L 61: ajout de graph2D dans les USES pilotage,
{ 03.04.01 : FO : nouvelles procdures
{                   function SetX2D:integer;far;    function SetY2D:integer;far;                          }
{                   function Concat1D;                                                            }
{                   function Remap2DtoQxQz:integer;far                                }
{ 06.06.01 : FO : ajout des procdures SetCurrentFXY pour le reglage automatique des flippers }
{ 12.06.06 : EL : ajout setExpCond et SetComment                                               }
{ 15.06.01 : EL : nouvelle fonction SommeDNPA pour somme petits angles exacte}
{ 20.06.01 : FO : ajout de deux procedures setCurrentBoss et setVoltageBoss }
{                 ces deux procedures supposent que la Boss508 est deja bien configure       }
{ 9.07.01 : EL : nouvelle fonction masquesecteur}
{ 10.07.01 : EL : - Cration de openspectre qui permet d'ouvrir un spectre au nouveau format                }
{                 - Cration de NormMoniSpectre2D qui normalise le moniteur d'un spectre 2D }
{ 16.07.01 : EL : Modification de la procedure traitstring pour utilisation du parametre string des variables }
{                 effet - les tableaux pars et par sont rinitialiss avant chaque instruction,
                        - en cas d'utilisation de variable, le parametre pars[i] est initialis  la valeur de la variable et non a son nom comme precedement }
{                       - pour toute fonction, pars[i]=nom$ entraine l'initialisation pars[i]:=nom.p4     (le caractere # devient reserve)    }
{                       - pour toute fonction, pars[i]=@nom entraine l'initialisation pars[i]:=nom    (le caractere @ devient reserve)                                                          }
{                 cration de setstring. permet d'initialiser la valeur de p4   }
{16.07.01 : EL : Cration de variables type tableau                              }
{                - cration du parametre tvaripar.p5 array of real              }
{                - cration de la fonction settab[@nom,indice,value1,value2,...]  pour initialiser 7 elements du tableau nom}
{                - modification de la procedure traitstring :    }
{                  l'utilisation de nom#expression entraine par[i]=nom.p5[expression]                             }
{ 18.07.01 : EL : Netoyage divers
{ 01.09.01 : FO : procedure d'intialisation de la BOSS                                        }
{ 20.09.01 : EL : plus nouvelles procedures StartPolAlt,initTOF,startTOF,ReadDataTOF,RMNirrad
                 modification de acqsimple2D,testacqsimple2D,addcomment et de la procedure ScriptStopButtonClick pour inclure PAPOL
{ 21.09.01 : EL: modification des procedures savetoASCII                 }
{ 19.10.01 : EL: ajout de la procedure setvout                           }
{ 03.10.01 : FO : ajout de { fonction de changement du type de polarisation lors de l'acquisition }
{                 function SetPolarisationType:integer;far; }
{ 29.11.01 : EL : Modifs pour changement RMNacqui<>pilotageRMN  }
{ 10.12.01 : FO : nouvelle procedure AcqsimplePSD               }
{                 nouvelles variables 'Nup' 'Mup' 'Ndo' 'Mdo' pour les mesures avec PSD sans analyse }
{                 variable 'integrale' qui contient le nombre de coups entre les "bounds"            }
{                 c'est la variable utile lors d'un comptage avec le PSD                             }
{ 12.03.02 : FO : nouvelle procdure "SetTime" permettant de changer le temps de comptage            }
{                 la variable "temps" ne fonctionne plus                                             }
{ ================================================== }
{ A FAIRE                                             }
{ documenter les functions : INPUT; OUTPUT, IMPLICIT CHANGES }
{ crer des variables de type tableau                        }
{ il faut pouvoir traiter les fichiers sous la forme de batches }
{ problemes de l'incrmentation des numros de fichier          }
{ Le mieux serait de disposer d'une fonction "str" qui convertit une nombre en chaine }
{ et de pouvoir additionner les chaines                }
{ ex. nom=concat["monfichier",str(i),".txt"];           }
{ la partie dlicate me semble tre la fonction str    }
{ FAIRE UN SYNTAXE CHEKCKER SUR LE PARSER ET AMELIORER LA GESTION DES ERREURS }
{ update des combo aprs les calculs                     }
{ mettre a jour la liste des fonctions disponibles }
{ procdures pour les calculs sur les spectres 1D }
{ toujours definir les types des data dans les spectres 2D i.e. au moins "='raw' !!! }

interface

{$IFDEF PILOTAGE }
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, multimemo, Parser10, StdCtrls, Menus, Db, DBTables,editdata,
  boss508, ips12010,graph2D,AT_AOMIO;
{$ENDIF }
{$IFDEF TRAITEMENT }
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, multimemo, Parser10, StdCtrls, Menus, Db, DBTables, editdata,graph2D;
{$ENDIF }

const
repseq='c:\sequences\';
seqext='.seq';
wm_redessine=$403+wm_user;
type
EvarError = class(Exception);

type
tvaripar = class(tobject)
       public
       value:extended;
       p1:integer;
       p2:double;
       p3:double;
       p4: string;
       p5: array of real;
end;
type
  Tinterpreteurform = class(TForm)
    Panel1: TPanel;
    Parser1: TParser;
    ScriptExecuteButton: TButton;
    Timer1: TTimer;
    ScriptExecuteSelectionButton: TButton;
    ScriptStopButton: TButton;
    Panel2: TPanel;
    Edit1: TEdit;
    Label1: TLabel;
    mem1: tmultimemo;
    MainMenu1: TMainMenu;
    suividevariable1: TMenuItem;
    variables1: TMenuItem;
    fonctions1: TMenuItem;
    ContinueButton: TButton;
    Tablemot: TTable;
    DataSourcemot: TDataSource;
    TablemotIndex: TIntegerField;
    TablemotZero: TIntegerField;
    TablemotDepart: TIntegerField;
    TablemotFin: TIntegerField;
    TablemotInc: TIntegerField;
    TablemotNomcourt: TStringField;
    TablemotAutorisation: TIntegerField;
    fonctionsmathmatiques1: TMenuItem;
    fonctionsduprogramme1: TMenuItem;
    ScriptStatus: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure ScriptExecuteButtonClick(Sender: TObject);
    procedure ScriptExecuteSelectionButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
    procedure suividevariable1Click(Sender: TObject);
    procedure ScriptStopButtonClick(Sender: TObject);
    procedure ContinueButtonClick(Sender: TObject);
    procedure variables1Click(Sender: TObject);
    procedure fonctions1Click(Sender: TObject);
    procedure Parser1ParserError(Sender: TObject; E: Exception);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Dclarations prives}
    filename:string;
    actlig,actligf:tstringlist; {tableau des ordres  effectuer}
    procedure addmotorlist;
    procedure pretraitement;
    procedure execution;
    function traitstring(s:string;ind:integer):integer;
   public
    { Dclarations publiques}

    seqencours:integer;{sequence en cours}
    procedure addvariable(name:string;value:integer;p1:integer;p2:double;p3:double;p4:string;tpro:tobject);
    procedure setvaleur(name:string;value:integer);
    procedure executeseq(name:string);
 end;

var
  interpreteurform: Tinterpreteurform;

implementation
{$IFDEF PILOTAGE }
uses suividesvariables, variablesliste, functionsliste,interfaceMoteurs, SuiviAcquisitionPRISM,
  MainForm, BoiteNoire, comptage2D, operations, gpib_CEC, PilotageRMN,
  visu_polarisation, ComptagePSDForm, comptage2DTOF;
{$ENDIF }
{$IFDEF TRAITEMENT }
uses suividesvariables, variablesliste, functionsliste, BoiteNoire, TraitementMainForm;
{$ENDIF }


var
  ordre,variable,varpar,labels:tstringlist;
  par:array[1..10] of extended;
  pars:array[1..10] of  string;
  param:array[0..200] of tvaripar;
  labelstab:array[0..26] of integer;
  seqon,seqlig:integer;
  flagwaitchamp,flagwaittemp:boolean;
  flagwaitacquis,flagwaitmotor:boolean;
  flagwaitacquisPSD:boolean;
  flagWaitEnergizing:boolean; { flag qui indique que l'on est en train d'energiser la bobine supra }
  CurrentValue:double; { valeur actuelle du courant }
{ =================================================================== }
{ A cet endroit se crent toutes les fonctions
destines  appeler les diffrentes routines}



{********************************************* }
{ fonctions de bases de l'interpreteur}
{********************************************* }

    function rien(s:string):integer; far;
    begin
    result:=0;
    end;

    function delay:integer;far; {stop l'execution du timer1 pendant par[1] seconde}
    var t0,t,temps:real;
    begin
    interpreteurform.timer1.enabled:=false;
    t0:=(time-int(time))*86400;  {temps en s}
    temps:=par[1];
    repeat
      t:=(time-int(time))*86400;
      if t<t0 then t:=t+86400;  {correction bug passage par minuit}
      Application.processMessages;
    until ((t-t0)>temps);
    result:=0;
    interpreteurform.timer1.enabled:=true;
    end;
    {fonctions boite noire}
    function addcomment:integer;far;
    var
    s:string;
    begin
    s:=pars[1]+pars[2]+pars[3]+pars[4]+pars[5]+pars[6]+pars[7]+pars[8]+pars[9]+pars[10];
    boitnoir.receivetext(s);
    result:=1;
    end;

    {fonction permettant d'initialiser le parametre p4 de la variable pars[1] }
    {cette fonction concat l'ensemble des elements de pars (sauf le premier}
    { INPUT: pars[1] : nom de la variable (entre en @nom)
             pars[2..10] : lments concatenes
    {OUPUT : le parametre p4 de la variable nom}
    function Setstring:integer;far;
    var temp:string;
        i:integer;
    begin
    temp:='';
    for i:=2 to 10 do
        temp:=temp+pars[i];

    param[variable.indexof(pars[1])].p4:=temp;
    end;

    {fonction permettant d'initialiser le tableau p5 de la variable pars[1] }
    { INPUT: pars[1] : nom de la variable (entre en @nom),
             par[2] : indice de dpart,
             par[3],..., par[10]: valeur
    {OUPUT : les parametres p5[par[2]],...,p5[par[2]+7] de la variable pars[1]}
    function Settab:integer;far;
    var vind:integer;
        i:integer;
    begin
    vind:=variable.indexof(pars[1]);
    for i:=0 to 7 do
        if pars[3+i]<>'' then
        begin
        {verification taille }
        if length(param[vind].p5)<(round(par[2])+i+1 ) then setlength(param[vind].p5,round(par[2])+i+1);
        {affectation}
        param[vind].p5[round(par[2])+i]:=par[i+3];
        end;
    end;

    {ajoute un point  un graph}
    {par[1]=1 ou 2 :dim
     pars[2] Nom du spectre
     par[3],par[4],par[5],par[6],par[7] : x,y,lt,z,mon}
    function addpt:integer;far;
    begin
    if par[1]=1 then und.addpt(pars[2],par[3],par[4],par[5],par[6],par[7]);
    if par[1]=2 then deuxd.addpt(pars[2],par[3],par[4],par[5],par[6],par[7]);
    result:=1;
    {$IFDEF PILOTAGE }
    sendmessage(principalform.handle,wm_redessine,0,0);
    {$ENDIF }
    {$IFDEF TRAITEMENT }
    {sendmessage(TraitementMainForm.handle,wm_redessine,0,0);  }
    {$ENDIF }
    end;
{********************************************* }
{debut de la partie propre  PILOTAGE}
{********************************************* }
{$IFDEF PILOTAGE }
    function fixtimer(s:string):integer; far;
    var
    i:extended;
    begin
    i:=param[variable.indexof(s)].value;
    if i=0 then
    interpreteurform.timer1.enabled:=false else
    interpreteurform.timer1.interval:=round(i);
    result:=0;
    end;
{fonction associes aux variables moteurs}
    function movabs(s:string):integer; far;
    begin
    result:=0;
    end;

    function settable(s:string):integer; far;
    var
    i:integer;
    begin
    i:=variable.indexof(s);
    if tabmot<>nil then tabmot.setval((param[i].p1),round(param[i].p2),round(param[i].value));
    result:=0;
    end;


{fonctions d'attente}


    function waitchamp:integer;far;
    begin
    flagwaitchamp:=true;
    result:=0;
    end;

    function waittemp:integer;far;
    begin
    flagwaittemp:=true;
    result:=0;
    end;

    function pause:integer;far;
    begin
    interpreteurform.timer1.enabled:=false;
    result:=0;
    end;

    function waitmotors:integer;far;
    begin
    if tabmot<>nil then flagwaitmotor:=true;
    result:=0;
    end;

{fonction acquisition PRISM}

    function acqsimple:integer; far;
    begin
    if suiviPRISMForm<>nil then suiviPRISMForm.acqsimple(par[1],par[2],par[3],par[4]);
    result:=1;
    flagwaitacquis:=true;
    end;

    function acqsimplePSD:integer; far;
    begin
    if comptagePSD<>nil then comptagePSD.lancementComptage(pars[1],pars[2],par[3],par[4],par[5],par[6]);
    result:=1;
    flagwaitacquisPSD:=true;
    end;
    
    function addcond:integer;far;
    var
    s:string;
    begin
    if suiviPRISMForm<>nil then begin
    s:=pars[1]+' polar :'+suiviPRISMForm.getpolar;
    boitnoir.receivetext(s);
    end;
    result:=1;
    end;

{fonction acquisition PAPOL}

    {permet de lancer un comptage en polarisation alterne
    INPUT par[1] temps total en s,
          par[2] dure d'une alternance UP en s,
          par[3] dure d'une alternace down en s}
    function StartPolAlt:integer; far;
    begin
    interpreteurform.timer1.enabled:=false;
    operationform.LancerPolAlter(par[1],par[2],par[3]);
    interpreteurform.timer1.enabled:=true;
    end;
    {lance une acquisition simple 2D de par[1] seconde, si pars[2]='wait' l'interpreteur attend la fin de
    l'acquisition pour passer  l'instruction suivante}
    function acqsimple2D:integer; far;

    begin
    interpreteurform.timer1.enabled:=false;
       if (comptage2Dform<>nil) then
          if not(comptage2DForm.testacquis) then comptage2Dform.acquisitionSimple2D(round(par[1]));
       if (comptage2DTOFform<>nil) then
          if not(comptage2DTOFform.testacquis) then comptage2DTOFform.acquisitionSimple2D(round(par[1]));
       if pars[2]='wait' then flagwaitacquis:=true else flagwaitacquis:=false;
       result:=1;
       interpreteurform.timer1.enabled:=true;
    end;

    {test la fin de l'acquisition 2D et charge la variable acq2d
    acq2d=1 l'acquisition est en cours}
    function testacqsimple2D:integer; far;

    begin
       if (comptage2Dform<>nil) then
          if (comptage2DForm.testacquis) then
            interpreteurform.parser1.setvariable('acq2d',1)
            else
            interpreteurform.parser1.setvariable('acq2d',0);
       if (comptage2DTOFform<>nil) then
          if (comptage2DTOFForm.testacquis) then
            interpreteurform.parser1.setvariable('acq2d',1)
            else
            interpreteurform.parser1.setvariable('acq2d',0);
    result:=1;
    end;
{fonctions d'acquisition TOF pour PAPOL}
    {initialisation TOF}
    function initTOF:integer;far;
    begin
    interpreteurform.timer1.enabled:=false;
    if (comptage2DTOFform<>nil) then comptage2DTOFform.intitialisationTOF;
    interpreteurform.timer1.enabled:=true;
    end;
    function rebootTOF:integer;far;
    begin
    interpreteurform.timer1.enabled:=false;
    if (comptage2DTOFform<>nil) then comptage2DTOFform.rebootageTOF;
    interpreteurform.timer1.enabled:=true;
    end;
    {permet de synchroniser le comptage sur une alternance UP du comptage}
    function startTOF:integer;far;
    begin
    interpreteurform.timer1.enabled:=false;
    if (comptage2DTOFform<>nil) then comptage2DTOFform.startTOF;
    interpreteurform.timer1.enabled:=true;
    end;
    {permet de lire les data TOF en cours de comptage}
    function readdataTOF:integer;far;
    begin
    interpreteurform.timer1.enabled:=false;
    if (comptage2DTOFform<>nil) then comptage2DTOFform.readdataTOF;
    interpreteurform.timer1.enabled:=true;
    end;

{fonctions Annexes PRISM}
    function addangles:integer;far;
    begin
    if tabmot<>nil then tabmot.ecritangles;
    result:=1;
    end;
    function fixtemps(s:string):integer; far;
    begin
    if suiviPRISMForm<>nil then suiviPRISMForm.fixtemps(round(param[variable.indexof(s)].value));
    result:=0;
    end;

    function comptcond(s:string):integer; far;
    begin
    if suiviPRISMForm<>nil then suiviPRISMForm.comptcond(param[variable.indexof(s)].p1,round(param[variable.indexof(s)].value));
    result:=0;
    end;

    function fixflip(s:string):integer; far;
    begin
    if suiviPRISMForm<>nil then suiviPRISMForm.fixflip(pars[1]);
    result:=0;
    end;

    function polarisation:integer;far;
    begin
    if suiviPRISMForm<>nil then suiviPRISMForm.fixpolar(pars[1]);
    result:=1;
    end;

    function fixcompt:integer;far;
    begin
    if suiviPRISMForm<>nil then suiviPRISMForm.fixcompt(pars[1]);
    result:=1;
    end;

{ fonctions RMN PAPOL}
    {modification du synthe
    INPUT: par[1] frequence centrale en MHz
           par[2] amplitude de modulation en kHz
           par[3] nivau en dBm
           pars[4] :F1,F2,...,F6}
    function RMNirrad:integer;far;
    begin
    {if RMNbase<>nil then
       begin
       RMNbase.initirrad(par[1],par[2],par[3],pars[4]);
       end; }
    end;
    {entraine une saturation RMN de par[1] ms, le timer de l'interpreteur est bloqu}
    function RMNsaturation:integer;far;
    begin
    {if RMNbase<>nil then
       begin
       interpreteurform.timer1.enabled:=false;
       RMNbase.synthe_sature(par[1]);
       interpreteurform.timer1.enabled:=true;
       end;     }
    result:=1;
    end;

    {lit la polarisation conformement au choix de la fiche (sauf nombre de passage) pilotageRMN et transfert dans les variables temps et polar}
    function RMNlitpolar:integer;far;
    var pol,t:real;
    begin
    interpreteurform.timer1.enabled:=false;
    if pilotageRMNForm<>nil then pilotageRMNForm.mesurepolar(round(par[1]),pol,t);
    interpreteurform.parser1.setvariable('temps',t);
    interpreteurform.parser1.setvariable('polar',pol);
    result:=1;
    interpreteurform.timer1.enabled:=true;
    end;

    {permet de faire un acquisition RMN avec ou sans prise du signal de base}
    function RMNavecBase:integer;far;
    begin
    if pilotageRMNForm<>nil then pilotageRMNForm.base.checked:=(pars[1]='true');
    result:=1;
    end;

    {permet d'ajouter un point visupol}
    function addpol:integer;far;

    begin
    if visupol<>nil then visupol.ajoute(par[1],par[2]);
    end;

    {permet de rinitialiser visupol}
    function clearvisupol:integer;far;
    begin
       if visupol<>nil then visupol.clearvisu;
    end;

{ =============================================== }
{ fonctions de pilotage de courants et de tension }

    {utilisable avec la source de courant Keythley 195 }
    function setcurrent:integer;far;
    var
      buf: packed array[0..50] of char; {* R/W buffer.*}
      buffer:string[50];
      adresseK220:integer;
    begin
       adresseK220:=12;
       buf := 'F0X'+#13#10;
       GPIBSend(AdresseK220,buf);
       buf := 'I9.5E-8X'+#13#10;
       GPIBSend(AdresseK220,buf);
       buf := 'D0X'+#13#10;
       GPIBSend(AdresseK220,buf);
       buf := 'V001X'+#13#10;
       GPIBsend(AdresseK220,buf);
    { I on }
      buf := 'F0X'+#13#10;
      gpibsend(12,buf);
    { set le courant }
      currentValue:=strToFloat(pars[1]);
      buffer := 'I'+formatfloat('#.###E-0',currentValue)+'X'+#13#10;
      strpcopy(buf,buffer);
      gpibsend(12,buf);
    { I off }
      buf := 'F1X'+#13#10;
      gpibsend(12,buf);
      result:=1;
    end;

    { utilisable avec le voltmtre AOIP MN5140 }
    function getvoltage:integer;far;
    var s,S1,s2,s3,s4:string;
    begin
    gpibsend(17,'Moy ?');
    gpibread(17,s,255);
    gpibread(17,s1,255);
    s4:=copy(s,1,9);
    { sauvegarde des data dans la boite noire }
    s2:='Multimetre : '+#9+s+#9+s4;
{    s3:='Multimetre : '+#9+s1; }
    boitnoir.receivetext(s2);
{    boitnoir.receivetext(s3); }
    interpreteurform.parser1.setvariable('Voltage1',StrToFLoat(s4));
    result:=1;
    end;

    { allumer/etiendre le Wiltron  }
    function WiltronON:integer;far;
    begin
    gpibsend(20,'RF1');
    result:=1;
    end;

    { allumer/etiendre le Wiltron  }
    function WiltronOFF:integer;far;
    begin
    gpibsend(20,'RF0');
    result:=1;
    end;


{ ================================================================== }
{ initialisation de la BOSS508 }
    Function Init_BOSS508:integer;
    begin
    Initialize_BOSS508(7);
    end;

{ initialisation de la BOSS508 }
    Function SetAsCurrentSource_BOSS508:integer;
    begin
    SetCurrentSource_BOSS508(7);
    end;
{ initialisation de la BOSS508 }
    Function SetAsVoltageSource_BOSS508:integer;
    begin
    SetVoltageSource_BOSS508(7);
    end;

{fonction de commande directe de l'alim Boss}
    function SetCurrentBoss:integer;far;
    begin
    SetCourant_BOSS508(7,par[1]);
    end;

{fonction de commande directe de l'alim Boss}
    function SetVoltageBoss:integer;far;
    begin
    SetTension_BOSS508(7,par[1]);
    end;
{ ======================================================================== }

   { pilotage de l'alimentation bobine supra Oxford }
   { on fixe le champ longitudinal                  }
   { INPUT: le champ en teslas                      }
   { OUTPUT: l'alim dmarre la squence pour changer le champ }
    function SetFieldL:integer;far;
    begin
    { a terme, il faudra passer par operations }
         SetField_IPS12010(25,par[1]);
    { il faut attendre que toute la squence d'nergisation et de denegrisaion soit finie }
    { ca dure quand meme 1 minute avec les sweep inclus                                    }
         flagWaitEnergizing:=true;
    end;

{ fonction de changement du type de polarisation lors de l'acquisition }
    function SetTime:integer;far;
    var s:string;
    begin
         s:=Uppercase(pars[1]);
         suiviPRISMform.countingTime.value:=round(par[1]);suiviPRISMform.countingTime.update;
{         ComptagePSD.countingTime.value:=round(par[1]);ComptagePSD.countingTime.update; }
    end;

{ fonction de changement du type de polarisation lors de l'acquisition }
    function SetPolarisationType:integer;far;
    var s:string;
    begin
         s:=Uppercase(pars[1]);
         if s='SIMPLE ++' then suiviPRISMform.spinstates.itemindex:=0;
         if s='SIMPLE --' then suiviPRISMform.spinstates.itemindex:=1;
         if s='SIMPLE +-' then suiviPRISMform.spinstates.itemindex:=2;
         if s='SIMPLE -+' then suiviPRISMform.spinstates.itemindex:=3;
         if s='DOUBLE ++/--' then suiviPRISMform.spinstates.itemindex:=4;
         if s='DOUBLE ++/+-' then suiviPRISMform.spinstates.itemindex:=5;
         if s='DOUBLE ++/-+' then suiviPRISMform.spinstates.itemindex:=6;
         if s='DOUBLE --/+-' then suiviPRISMform.spinstates.itemindex:=7;
         if s='DOUBLE --/-+' then suiviPRISMform.spinstates.itemindex:=8;
         if s='DOUBLE +-/-+' then suiviPRISMform.spinstates.itemindex:=9;
         if s='TRIPLE ++/--/+-' then suiviPRISMform.spinstates.itemindex:=10;
         if s='TRIPLE ++/--/-+' then suiviPRISMform.spinstates.itemindex:=11;
         if s='TRIPLE ++/-+/+-' then suiviPRISMform.spinstates.itemindex:=12;
         if s='TRIPLE --/-+/+-' then suiviPRISMform.spinstates.itemindex:=13;
         if s='TOUT' then suiviPRISMform.spinstates.itemindex:=14;
    end;

{ pilotage des courants dans les flippers }
    function SetCurrentF1H:integer;far;
    begin
        OperationForm.SetCourantFlipper1H(par[1]);
    end;
    function SetCurrentF1V:integer;far;
    begin
        OperationForm.SetCourantFlipper1V(par[1]);
    end;
    function SetCurrentF2H:integer;far;
    begin
        OperationForm.SetCourantFlipper2H(par[1]);
    end;
    function SetCurrentF2V:integer;far;
    begin
        OperationForm.SetCourantFlipper2V(par[1]);
    end;


{fonction pilotage de tension PAPOL}
    function SetVout:integer;far;
    begin
    if (comptage2DTOFform<>nil)  or (comptage2Dform<>nil) then
    begin
    if par[1]=1 then setvout1(par[2]);
    if par[1]=3 then setvout3(par[2]);
    if par[1]=4 then setvout4(par[2]);
    if par[1]=5 then setvout5(par[2]);
    end
    end;

{$ENDIF }
{********************************************* }
{fin de la partie propre  PILOTAGE}
{********************************************* }

{ ======================================================================= }
{fonction gnrales sur les spectres }

    {fonction permettant de modifier les conditions experimentalles d'un spectre
    INPUT par[1] 1:und ,2:deuxd, 3:3d
          pars[2]:nom du spectre
          pars[3]:nom de la condition experimentalle
          par[4]:valeur de la condition}

    function SetExpCond:integer;far;
    var vind:integer;
    begin
    if par[1]=1 then
       begin
       vind:=und.indexof(pars[2]);
       if vind<>-1 then
       und.spect[vind].SetExpCond(pars[3],par[4]);
       end;
    if par[1]=2 then
       begin
       vind:=deuxd.indexof(pars[2]);
       if vind<>-1 then
       deuxd.spect[vind].SetExpCond(pars[3],par[4]);
       end;
    if par[1]=3 then
       begin
       vind:=troisd.indexof(pars[2]);
       if vind<>-1 then
       troisd.spect[vind].SetExpCond(pars[3],par[4]);
       end;
    end;
    {fonction permettant de modifier le commentaire d'un spectre
    INPUT par[1] 1:und ,2:deuxd, 3:3d
          pars[2]:nom du spectre
          pars[3],..,par[10]:commentaire}
    function SetComment:integer;far;
    var vind:integer;
    begin
    if par[1]=1 then
       begin
       vind:=und.indexof(pars[2]);
       if vind<>-1 then
       und.spect[vind].comment:=pars[3]+pars[4]+pars[5]+pars[6]+pars[7]+pars[8]+pars[9]+pars[10];
       end;
    if par[1]=2 then
       begin
       vind:=deuxd.indexof(pars[2]);
       if vind<>-1 then
       deuxd.spect[vind].comment:=pars[3]+pars[4]+pars[5]+pars[6]+pars[7]+pars[8]+pars[9]+pars[10];
       end;
    if par[1]=3 then
       begin
       vind:=troisd.indexof(pars[2]);
       if vind<>-1 then
       troisd.spect[vind].comment:=pars[3]+pars[4]+pars[5]+pars[6]+pars[7]+pars[8]+pars[9]+pars[10];
       end;
    end;

    {mise a Zero d'un spectre}
    {par[1]=1,2,3 dim; pars[2] : nom du spectre}
    function clearspectre:integer;far;
    begin
    if par[1]=1 then und.clear(pars[2]);
    if par[1]=2 then deuxd.clear(pars[2]);
    if par[1]=3 then troisd.clear(pars[2]);
    result:=1;
    end;
    {permet de crer un spectre en mmoire vive}
    {par[1] =1,2,3 Dim du spectre,
     pars[2] nom du spectre,
     par[3],par[4],par[5] dim X,Y,LT  }
    function addspectre:integer;far;
    begin
    if par[1]=1 then und.addspectre(pars[2],round(par[3]),round(par[4]),round(par[5]));
    if par[1]=2 then deuxd.addspectre(pars[2],round(par[3]),round(par[4]),round(par[5]));
    if par[1]=3 then troisd.addspectre(pars[2],round(par[3]),round(par[4]),round(par[5]));
    result:=1;
    end;


{ ======================================================================= }
{ fonctions de lecture/ecriture de spectres }

    { lecture d'un spectre sauv sur le disque (ancien format)}
    { A MODIFIER OU SUPPRIMER }
    { INPUT: nom fichier du spectre}
    { OUTPUT: le spectre est transfr dans spect[1] }
    function readspectre1D:integer;far;
    begin
    dataeditform.litspectre1D(pars[1]);
    result:=1;
    end;
    {lecture fichier 2D ancien format
    INPUT pars[1] nom du fichier
          pars[2] nom du spectre}
    function readspectre2D:integer;far;
    var vind:integer;
    begin
    interpreteurform.timer1.enabled:=false;
    vind:=deuxd.indexof(pars[2]);
    if vind<0 then vind:=deuxd.addspectre(pars[2],1,1,1);

    if editdata.fexis(pars[1]) then
      begin
      deuxd.spect[vind].readfromfile(pars[1]);
      boitnoir.receivetext('ouverture de : ' + pars[1]+' dans : '+pars[2]);
      end
    else
      boitnoir.receivetext('!! echec ouverture : ' + pars[1]+' n existe pas');

    interpreteurform.timer1.enabled:=true;
    result:=1;
    end;

    {procedure de sauvegarde gnrale ancien format}
    {A SUPPRIMER ??
    function savespectre:integer;far;
    begin
    dataeditform.sauve(round(par[1]),pars[2]);
    result:=1;
    end;           }

    {lecture HADAS }
    {!! Le chemin est IMPOSE}
    function lectureFichierHADAS:integer;far
    var s:string;
    begin
         s:=pars[1]+IntToStr(round(par[2]));
         graph2D.lectureFichierHADAS('d:\temp\'+s+'.img');
    end;

    { INPUT: pars[1], le nom du spectre  sauvegarder }
    {        pars[2], le nom du fichier (avec chemin) }
    {        pars[3]+..+pars[10], le commentaire en premire ligne }

    function saveToASCII1D:integer;far;
    var fich:text;
        i,ind:integer;
    begin
         interpreteurform.timer1.enabled:=false;
         ind:=und.indexof(pars[1]);
         if ind<>-1 then begin
         assignfile(fich,pars[2]);
         rewrite(fich);
         writeln(fich,pars[3]+pars[4]+pars[5]+pars[6]+pars[7]+pars[8]+pars[9]+pars[10]); { ecriture d'un commentaire en premire ligne }
         writeln(fich,FloatToStr(und.spect[ind].X)); { ecriture de la longeur du spectre 1D en deuxime ligne }
         writeln(fich,FloatToStr(und.spect[ind].Y)); { ecriture de la longeur du spectre 1D en troisime ligne }
         writeln(fich,FloatToStr(und.spect[ind].LT));{ ecriture de la longeur du spectre 1D en quatrime ligne }
         for i:=0 to und.spect[ind].X-1 do
             writeln(fich,FloatToStr(und.spect[ind].data[i,0,0].x)+#9+FloatToStr(und.spect[ind].data[i,0,0].z));
         closefile(fich);
         end;
         interpreteurform.timer1.enabled:=true;
    end;
    { INPUT: pars[1], le nom du spectre a sauvegarder }
    {        pars[2], le nom du fichier (avec chemin) }
    {        pars[3]+..+pars[10], le commentaire en premire ligne }
    {OUTPUT : Fichier type 4 col : X,Y,Z(=0), data     }
    function saveToASCII2D:integer;far;
    var fich:text;
        i,j,ind:integer;
    begin
         interpreteurform.timer1.enabled:=false;
         ind:=deuxd.indexof(pars[1]);
         if ind<>-1 then begin
         assignfile(fich,pars[2]);
         rewrite(fich);
         writeln(fich,pars[3]+pars[4]+pars[5]+pars[6]+pars[7]+pars[8]+pars[9]+pars[10]); { ecriture d'un commentaire en premire ligne }
         writeln(fich,FloatToStr(deuxd.spect[ind].moniteur));
         {writeln(fich,FloatToStr(deuxd.spect[ind].X));  ecriture de la longeur du spectre 2D en deuxime ligne
         writeln(fich,FloatToStr(deuxd.spect[ind].Y)); { ecriture de la longeur du spectre 2D en troisime ligne
         writeln(fich,FloatToStr(deuxd.spect[ind].LT)); { ecriture de la longeur du spectre 2D en quatrime ligne }
         for i:=0 to deuxd.spect[ind].X-1 do
             for j:=0 to deuxd.spect[ind].Y-1 do
                 {writeln(fich,intToStr(i)+#9+intToStr(j)+#9+'0'+#9+FloatToStr(deuxd.spect[ind].data[i,j,0].z));}
                 writeln(fich,FloatToStr(deuxd.spect[ind].data[i,j,0].z));
         closefile(fich);
         end;
         interpreteurform.timer1.enabled:=true;
    end;
    {fonction d'ouverture de spectre au nouveau format}
    {INPUT : par[1] : dim du spectre (=1,2,3)
             pars[2] : nom du fichier
             pars[3] : nom du spectre recepteur}
    function openspectre:integer;far;
    var dim,ind:integer;

    begin
    interpreteurform.timer1.enabled:=false;
    dim:=round(par[1]);
    if editdata.fexis(pars[2]) then
    begin
    case dim of
    1: begin
       ind:=und.addspectre(pars[3],1,1,1);
       und.spect[ind].open(pars[2]);
       end;
    2: begin
       ind:=deuxd.addspectre(pars[3],1,1,1);
       deuxd.spect[ind].open(pars[2]);
       end;
    3: begin
       ind:=troisd.addspectre(pars[3],1,1,1);
       troisd.spect[ind].open(pars[2]);
       end;
    end;
    
    end
    else boitnoir.receivetext('!! echec ouverture : ' + pars[2]+' n existe pas');
    interpreteurform.timer1.enabled:=true;
    end;
    {fonction de sauvegarde de spectre au nouveau format}
    {INPUT : par[1] : dim du spectre (=1,2,3)
             pars[2] : nom du fichier
             pars[3] : nom du spectre recepteur}
    function SaveSpectre:integer;far;
    var dim,ind:integer;

    begin
    interpreteurform.timer1.enabled:=false;
    dim:=round(par[1]);
    case dim of
    1: begin
       ind:=und.indexof(pars[3]);
       if ind>0 then und.spect[ind].save(pars[2]);
       end;
    2: begin
       ind:=deuxd.indexof(pars[3]);
       if ind>0 then deuxd.spect[ind].save(pars[2]);
       end;
    3: begin
       ind:=troisd.indexof(pars[3]);
       if ind>0 then troisd.spect[ind].save(pars[2]);
       end;
    end;
    interpreteurform.timer1.enabled:=true;
    end;
{ ======================================================================= }
{ ICI se trouvent les fonctions du script pour le traitement des spectres }
{ procdures agissant sur les spectres 1D }
    function DelSpectre1D:integer;far
    begin
         und.delete(pars[1]);
    end;
    function AddSpectre1D:integer;far;
    begin
         und.addition(pars[1],pars[2],pars[3]);
    end;
    function SubSpectre1D:integer;far;
    begin
       und.soustraction(pars[1],pars[2],pars[3]);
    end;
    function MultSpectre1D:integer;far;
    begin
       und.multiplication(pars[1],pars[2],pars[3]);
    end;
    function DivSpectre1D:integer;far;
    begin
       und.division(pars[1],pars[2],pars[3]);
    end;
    function ScalAddSpectre1D:integer;far;
    begin
        und.ScalAdd(par[1],pars[2],pars[3]);
    end;
    function ScalSubSpectre1D:integer;far;
    begin
        und.ScalSub(par[1],pars[2],pars[3]);
    end;
    function ScalMultSpectre1D:integer;far;
    begin
        und.ScalMult(par[1],pars[2],pars[3]);
    end;
    function ScalDivSpectre1D:integer;far;
    begin
        und.ScalDiv(par[1],pars[2],pars[3]);
    end;
    {integrale entre Xmin et Xmax
    pars[1] Nom1D
    par[2], par[3] xmin et xax  en Pixel si type raw ou absolue si une typeX<>raw
    par[4] nom variable parseur
    le rsultat est stok dans la boite noire
    ou dans la variable du parseur pars[4]si <>'' ex "var"}

    function IntegraleSpectre1D:integer;far
    var vind:integer;
        temp:real;
    begin
    vind:=und.indexof(pars[1]);
    if vind>0 then
       begin
       temp:=und.spect[vind].IntegraleSpectre1D(par[2],par[3]);
       if pars[4]<>'' then interpreteurform.parser1.setvariable(pars[6],temp)
       else  boitnoir.receivetext(floattostr(temp));
       end;
    end;
{ procdures agissant sur les spectres 2D }
    function DelSpectre2D:integer;far
    begin
         deuxd.delete(pars[1]);
    end;
    function AddSpectre2D:integer;far;
    begin
         deuxd.addition(pars[1],pars[2],pars[3]);
    end;
    function SubSpectre2D:integer;far;
    begin
         deuxd.soustraction(pars[1],pars[2],pars[3]);
    end;
    function MultSpectre2D:integer;far;
    begin
       deuxd.multiplication(pars[1],pars[2],pars[3]);
    end;
    function DivSpectre2D:integer;far;
    begin
       deuxd.division(pars[1],pars[2],pars[3]);
    end;
    function ScalAddSpectre2D:integer;far;
    begin
        deuxd.ScalAdd(par[1],pars[2],pars[3]);
    end;
    function ScalSubSpectre2D:integer;far;
    begin
        deuxd.ScalSub(par[1],pars[2],pars[3]);
    end;
    function ScalMultSpectre2D:integer;far;
    begin
        deuxd.ScalMult(par[1],pars[2],pars[3]);
    end;
    function ScalDivSpectre2D:integer;far;
    begin
        deuxd.ScalDiv(par[1],pars[2],pars[3]);
    end;
    {integrale entre Xmin, ymin, Xmax, ymax
    pars[1] Nom2D
    par[2], par[3],par[4], par[5], xmin, ymin,xmax, ymax
    par[6] nom variable parseur
    le rsultat est stok dans la boite noire
    ou dans la variable du parseur pars[6]si <>'' ex "var"}
    function IntegraleSpectre2D:integer;far
    var vind:integer;
        temp:real;
    begin
    vind:=deuxd.indexof(pars[1]);
    if vind>0 then
       begin
       temp:=deuxd.spect[vind].IntegraleSpectre2D(par[2],par[3],par[4],par[5]);
       if pars[6]<>'' then interpreteurform.parser1.setvariable(pars[6],temp)
       else  boitnoir.receivetext(floattostr(temp));
       end;

    end;
    {Normalise le spectre  un moniteur de reference}
    {par[1]:moniteur de ref, Pars[2]: spectre ini; pars[3]:spectre normalis}
    function NormMoniSpectre2D:integer;far;

    begin
    interpreteurform.timer1.enabled:=false;
    if deuxd.indexof(pars[2])<>-1 then
       begin
       if deuxd.spect[deuxd.indexof(pars[2])].moniteur<>0 then
         begin
         deuxd.ScalMult(par[1]/deuxd.spect[deuxd.indexof(pars[2])].moniteur,pars[2],pars[3]);
         deuxd.spect[deuxd.indexof(pars[3])].moniteur:=par[1];
         boitnoir.receivetext('normalisation :' + pars[2]+' moniteur ='+pars[1]);
         end
       else
         boitnoir.receivetext('!! echec normalisation :' + pars[2]+' moniteur nul');
       end
    else
       boitnoir.receivetext('!! echec normalisation :' + pars[2]+' non trouv');
    interpreteurform.timer1.enabled:=true;
    end;
{ fonctions de projection }
{ INPUT : pars[1], nom du spectre 2D}
{         par[2], ymin; par[3] ymax      }
{         pars[4], le nom du spectre 1D de sortie }
{ OUTPUT: le resultat est stock dans le spectre unD 'pars[4]' }
    function ProjectionHSpectre2D:integer;far
    var vind:integer;
    begin
        vind:=deuxd.indexof(pars[1]);
        if vind>0 then unD.add(deuxd.spect[vind].ProjectionHSpectre2D(pars[4],par[2],par[3]));
    end;
    function ProjectionVSpectre2D:integer;far
    var vind:integer;
    begin
        vind:=deuxd.indexof(pars[1]);
        if vind>0 then unD.add(deuxd.spect[vind].ProjectionVSpectre2D(pars[4],par[2],par[3]));
    end;


    function SommeCirculaireSpectre2D:integer;far
    begin
    end;
    {fonction appellant une somme petits angles

    INPUT : Pars[1]:nom du spectre 2D; pars[2]:nom du spectre 1D
            pars[3]:nom du masque (si ce masque n'existe pas, le prg n'utilise pas de masquage
            par[4],par[5]: X0, Y0 centre; par[6]: nombre de points (resolution)
            par[7]: lambda (PAPOL :8); par[8] : delta Pixel en m (PAPOl : 0.005); par[9]: dist Ech/detect en m
    OUTPUT: Spectre 1D pars[2]}
    function SommeDNPA:integer;far

    begin
    interpreteurform.timer1.enabled:=false;
    if deuxd.indexof(pars[1])<>-1 then
       begin
       und.add(deuxd.spect[deuxd.indexof(pars[1])].SommePetitsAngles(pars[2],pars[3],par[4],par[5],par[6],par[7],par[8],par[9]));
       boitnoir.receivetext('Somme DNPA :' + pars[1]+' dans '+pars[2]);
       if deuxd.indexof(pars[3])<0 then boitnoir.receivetext('!!ATTENTION : masque ' + pars[3]+' non trouv ');
       end
    else boitnoir.receivetext('!! echec Somme DNPA : ' + pars[1]+' non trouv');
    interpreteurform.timer1.enabled:=true;
    end;
    {fonction multipliant le spectre deuxd.indexof(Pars[1]) par un secteur de 1 et 0 ailleurs}
    {Pars[1]:nom du spectre 2D;par[2],par[3]: X0, Y0 centre du secteur}
    {par[4]: angle median du secteur en convention geographique: 0 a midi, 90 a 3H, 180 a 6H, 270 a 9H  }
    {par[5]: angle total d'ouverture du secteur (plus ou moins thetaouv/2)}
    function MasqueSecteur:integer;far
    begin
    if deuxd.indexof(pars[1])<>-1 then
    deuxd.spect[deuxd.indexof(Pars[1])].MasqueSecteur(Par[2],Par[3],Par[4],Par[5]);
    end;
    {Calcul le barycentre d'un spectre 2D afin de determiner le bean centre}
    {pars[1] : Nom du spectre 2D}
    function Barycentre2D:integer;far
    var vind,i,j:integer;
        X,Y,somme:real;
    begin
    vind:=deuxd.indexof(pars[1]);
    X:=0;Y:=0;somme:=0;
    if vind>0 then
      begin
      for i:=0 to deuxd.spect[vind].X-1 do
          for j:=0 to deuxd.spect[vind].Y-1 do
            begin
            X:=X+deuxd.spect[vind].data[i,j,0].z*i;
            Y:=Y+deuxd.spect[vind].data[i,j,0].z*j;
            somme:=somme+deuxd.spect[vind].data[i,j,0].z;
            end;
      if somme<>0 then
         begin
         X:=X/somme;Y:=Y/somme;
         end;
      boitnoir.receivetext('barycentre '+deuxd.spect[vind].nom+' : X0='+floattostr(X)+' Y0='+floattostr(Y));
      end;
    end;
    { fonction de concatenation de spectres 1D en un spectre 2D }
    { INPUT : pars[1], rpertoire de lecture   }
    {         pars[2], nom de base des fichiers 1D }
    {         par[3], indice min, par[5], indice max }
    {         par[4], le step     }
    {         pars[6], extension des fichiers    }
    {         pars[7], nomdu spectre 2d de sortie, nom interne au programme }
    function concat1D:integer;far;
    var fich:text;
        i,imin,imax,j,ind,longueurY:integer;
        s:string;
    begin
         imin:=round(par[3]);imax:=round(par[5]);
         { lecture de la taille des fichiers 1D }
         s:=pars[1]+pars[2]+intToStr(round(par[3]))+pars[6];
         assignfile(fich,s);reset(fich);
         readln(fich,s); { lecture du commentaire }
         readln(fich,s); { lecture de la longueur du spectre }
         longueurY:=StrToInt(s);
         { cration du nouveau spectre 2D }
         ind:=deuxd.addSpectre(pars[7],round((imax-imin)/par[4])+1,longueurY,1); { verifier que addSpectre rend bien le nouvel indice du spectre }
         deuxd.spect[ind].typeX:='raw';deuxd.spect[ind].typeY:='raw';
         { scanning de tous les fichiers }
         i:=imin;
         while i<=imax do
         begin
              assignfile(fich,pars[1]+pars[2]+intToStr(i)+pars[6]);
              reset(fich);
              readln(fich,s); { lecture du commentaire }
              readln(fich,s); { lecture de la longueur du spectre }
              for j:=0 to longueurY-1 do
                  begin
                  readln(fich,s);deuxd.spect[ind].data[round((i-imin)/par[4]),j,0].z:=StrToInt(s);
                  end;
              closefile(fich);
              i:=i+round(par[4]);
         end;
    end;
            { creation des echelles en X pour les graph 2D }
    { INPUT : pars[1] le nom d'un spectre 2D               }
    {         pars[2] la premire valeur                   }
    {         pars[3] le pas                               }
    {         pars[4] le nouveau type des data             }
    { OUTPUT : les champs .x des data sont mis a jour      }
    function SetX2D:integer;far;
    var i,j,ind:integer;
    begin
       ind:=deuxd.indexof(pars[1]);
       for j:=0 to deuxd.spect[ind].Y-1 do
          for i:=0 to deuxd.spect[ind].X-1 do
             deuxd.spect[ind].data[i,j,0].x:=par[2]+i*par[3];
       deuxd.spect[ind].typeX:=pars[4];
    end;
    { creation des echelles en X pour les graph 2D }
    { INPUT : pars[1] le nom d'un spectre 2D               }
    {         pars[2] la premire valeur                   }
    {         pars[3] le pas                               }
    { OUTPUT : les champs .x des data sont mis a jour      }
    function SetY2D:integer;far;
    var i,j,ind:integer;
    begin
       ind:=deuxd.indexof(pars[1]);
       for i:=0 to deuxd.spect[ind].X-1 do
          for j:=0 to deuxd.spect[ind].Y-1 do
             deuxd.spect[ind].data[i,j,0].y:=par[2]+j*par[3];
       deuxd.spect[ind].typeY:=pars[4];
    end;
    { remappage d'un spectre 2D des coordonnes (theta in;theta out) verx (Qz,Qx) }
    { on suppose Tin en X et Tout en Y    en DEGRES !!!                           }
    { les units de q sont les units de 1/lambda                                 }
    { INPUT : pars[1], spectre 2D a remapper                                      }
    {         par[2] lambda                                                       }
    {         par[3], qxmin; par[4], qxpas; par[5], qxmax;  (en nm-1)          }
    {         par[6], qxmin; par[7], qxpas; par[8], qxmax;                     }
    {         pars[9], le nom du nouveau spectre avec les data qx,qy              }
    { OUTPUT : on cre un nouveau spectre 2D avec les coordonnes qx,qy           }
    { REM : il faut que les .x et .y soit bien initialiss                        }
    { IL MANQUE LA NORMALISATION POUR LE MOMENT }
    { IL SEMBLE QU'ON COMPTE PLUS DE COUPS QUE DANS LE SPECTRE DE DEPART !!! }
    function Remap2DtoQxQz:integer;far
    var i,j,ind,qind:integer;
        qx,qy,qz,qXmin,qXmax,qXpas,qYmin,qYmax,qYpas:double;
        cste,ti,tf,auxP,auxM:double;
        ii,jj,iimax,jjmax:integer;
        dti,dtf,dqx,dqy,dqxdti,dqxdtf,dqydti,dqydtf:double;           { pas en theta initial et theta final }
    begin
       cste:=4*pi/par[2];
       ind:=deuxd.indexof(pars[1]); { spectre 2D a traiter }
       dti:=abs(deuxd.spect[ind].data[1,0,0].x-deuxd.spect[ind].data[0,0,0].x);
       dtf:=abs(deuxd.spect[ind].data[0,1,0].y-deuxd.spect[ind].data[0,0,0].y);
       { creation du nouveau spectre }
       qXmin:=par[3];qXpas:=par[4];qXmax:=par[5];
       qYmin:=par[6];qYpas:=par[7];qYmax:=par[8];
       iimax:=round((qxmax-qxmin)/qxpas);jjmax:=round((qymax-qymin)/qypas);
       qind:=deuxd.addspectre(pars[9],iimax,jjmax,1);
{       deuxd.spect[qind].typeX:='1/[L]';
       deuxd.spect[qind].typeY:='1/[L]'; }
       { en attendant que les projections acceptent les types autres que 'raw' }
       deuxd.spect[qind].typeX:='raw';
       deuxd.spect[qind].typeY:='raw';

       { initialisation des champs .X et .y pour le spectre en qx qz }
       for i:=0 to deuxd.spect[qind].X-1 do
          for j:=0 to deuxd.spect[qind].Y-1 do
          begin
             deuxd.spect[qind].data[i,j,0].x:=qxmin+i*qxpas;
             deuxd.spect[qind].data[i,j,0].y:=qymin+j*qypas;
          end;
       { on scan les points du spectre en t in  et t out }
       for i:=0 to deuxd.spect[ind].X-1 do
          for j:=0 to deuxd.spect[ind].Y-1 do
          begin
               ti:=deuxd.spect[ind].data[i,j,0].x*pi/180;
               tf:=deuxd.spect[ind].data[i,j,0].y*pi/180;
               auxP:=(ti+tf)/2;auxM:=(ti-tf)/2;
               { ces formules ne s'appliquent que pour les faisceaux reflechis !!! }
               { il y a des corrections a faire pour les faisceaux transmis   }
               qx:=cste*sin(auxP)*cos(auxM); { ACHTUNG, ca correspond a qz pour notations F.O. }
               qy:=cste*sin(auxP)*sin(auxM); { ACHTUNG ca correspond  qx pour notations F.O. }
               dqxdti:=0.5*cste*(cos(auxP)*cos(auxM)-sin(auxP)*sin(auxM));
               dqxdtf:=0.5*cste*(cos(auxP)*cos(auxM)+sin(auxP)*sin(auxM));
               dqydti:=0.5*cste*(cos(auxP)*sin(auxM)+sin(auxP)*cos(auxM));
               dqydtf:=0.5*cste*(cos(auxP)*sin(auxM)-sin(auxP)*cos(auxM));
               dqx:=dqxdti*dti+dqxdtf*dtf;dqy:=dqydti*dti+dqydtf*dtf;
               { dans quelle cellule doit-on mettre ces points }
               { il faut verifier si ca rentre dans le graph 2D }
               ii:=round((qx-qxmin)/qxpas);jj:=round((qy-qymin)/qypas);
               if (ii>=0) and (ii<iimax) and (jj>=0) and (jj<jjmax)
               then begin
                    { version normalise, mais ca pose des problmes pour le signe des dqxdti }
                     deuxd.spect[qind].data[ii,jj,0].z:=deuxd.spect[qind].data[ii,jj,0].z+deuxd.spect[ind].data[i,j,0].z/abs(dqx*dqy);
                    {deuxd.spect[qind].data[ii,jj,0].z:=deuxd.spect[qind].data[ii,jj,0].z+deuxd.spect[ind].data[i,j,0].z; }
                    end;
               { verification que la normalisation des surfaces des espaces reciproques est bonne }
          end;
    end;
{ ****** procdures agissant sur les spectres 3D }
    function DelSpectre3D:integer;far
    begin
         troisd.delete(pars[1]);
    end;
    function AddSpectre3D:integer;far;
    begin
         troisd.addition(pars[1],pars[2],pars[3]);
    end;
{Somme Total sur le spectre
    pars[1] Nom3D
    par[2] nom variable parseur
    le rsultat est stok dans la boite noire
    ou dans la variable du parseur pars[6]si <>'' ex "var"}
    function IntegraleSpectre3D:integer;far
    var vind,i,j,k:integer;
        temp:real;
    begin
    vind:=troisd.indexof(pars[1]);
    if vind>0 then
       begin
       temp:=0;
       for i:=0 to troisd.spect[vind].X-1  do
          for j:=0 to troisd.spect[vind].Y-1  do
              for k:=0 to troisd.spect[vind].LT-1  do
              temp:=temp+troisd.spect[vind].data[i,j,k].Z;

       if pars[2]<>'' then interpreteurform.parser1.setvariable(pars[2],temp)
       else  boitnoir.receivetext(floattostr(temp));
       end;

    end;
    function ReadMoni3D:integer;far
    var vind:integer;
        temp:real;

    begin
    vind:=troisd.indexof(pars[1]);
    if vind>0 then
       begin
       temp:=troisd.spect[vind].moniteur;
       if pars[2]<>'' then interpreteurform.parser1.setvariable(pars[2],temp)
       else  boitnoir.receivetext(floattostr(temp));
       end;
    end;
  {procedure permettant de separer un spectre troisd en spectre 2d (selon la dim LT)}
  {INPUT pars[1] : nom du spectre 3D
         pars[2] : nom du spectres 2D
         par[3]  : numero de frame 1<..<LT
         pars[4] : mode de calcul du moniteur
                   norm/nombre : divise le moniteur par le nombre de frame
                   norm/inter : multiplie le moniteur par l'intervale lt[i]-lt[i-1]
                   rien copie directement le moniteur}
  function Spectre3DTo2D:integer;far
  var vind3D,vind2D,i,j,l:integer;
      X,Y,LT:integer;
      delta:real;
  begin
  vind3d:=troisd.indexof(pars[1]);
  if vind3d>0 then
  begin
  X:=troisd.spect[vind3D].X;
  Y:=troisd.spect[vind3D].Y;
  LT:=troisd.spect[vind3D].LT;
  l:=round(Par[3])-1;
  if (l>=0) and (l<=LT-1) then
  begin
    {cration du spectre 2D recepteur}
    vind2D:=deuxd.addspectre(pars[2],X,Y,1);
    {chargement des data et echelle X,Y}
    for i:=0 to X-1 do
       for j:=0 to Y-1 do
          begin
          deuxd.spect[vind2D].data[i,j,0].x:=troisd.spect[vind3D].data[i,j,l].x;
          deuxd.spect[vind2D].data[i,j,0].y:=troisd.spect[vind3D].data[i,j,l].y;
          deuxd.spect[vind2D].data[i,j,0].z:=troisd.spect[vind3D].data[i,j,l].z;
          deuxd.spect[vind2D].data[i,j,0].lt:=troisd.spect[vind3D].data[i,j,l].lt;
          end;
    {chargement des infos}
    deuxd.spect[vind2D].comment:=troisd.spect[vind3D].comment;
    deuxd.spect[vind2D].typeX:=troisd.spect[vind3D].typeX;
    deuxd.spect[vind2D].typeY:=troisd.spect[vind3D].typeY;
    deuxd.spect[vind2D].typeLT:=troisd.spect[vind3D].typeLT;
    {chargement des conditions exprimentales}
    for i:=0 to troisd.spect[vind3D].ExpCondNbr-1 do
       deuxd.spect[vind2D].SetExpCond(troisd.spect[vind3D].experimentalConditions[i].name,troisd.spect[vind3D].experimentalConditions[i].value);

    deuxd.spect[vind2D].SetExpCond('lt',troisd.spect[vind3D].data[0,0,l].lt);

    {chargement du moniteur: 3 options en fonction de pars[3]}
    if pars[4]='norm/nombre' then
        begin {normalisation par le nombre de slice}
        deuxd.spect[vind2D].moniteur:=troisd.spect[vind3D].moniteur/LT; 
        deuxd.spect[vind2D].SetExpCond('NormMoniteur',1);
        end
    else
        if  pars[4]='norm/inter' then
            begin  {normalisation par la dure de la frame}
            if l=0 then delta:=troisd.spect[vind3D].data[0,0,l].lt
               else  delta:=troisd.spect[vind3D].data[0,0,l].lt-troisd.spect[vind3D].data[0,0,l-1].lt;
            deuxd.spect[vind2D].moniteur:=troisd.spect[vind3D].moniteur*delta;
            deuxd.spect[vind2D].SetExpCond('NormMoniteur',2);
            end
        else
            begin {pas de normalisation}
            deuxd.spect[vind2D].moniteur:=troisd.spect[vind3D].moniteur;
            deuxd.spect[vind2D].SetExpCond('NormMoniteur',0);
            end;
    end;
  end;
  end;
{****************************************************************************}
{                      FIN De L'implementation des fonctions interpreteur}
{************}
{                      DEBUT de l'interpreteur}
{****************************************************************************}


{$R *.DFM}

procedure Tinterpreteurform.FormCreate(Sender: TObject);
var
i:integer;
begin

seqon:=0;
actlig:=tstringlist.create;
actligf:=tstringlist.create;
variable:=tstringlist.create;
varpar:=tstringlist.create;
ordre:=tstringlist.create;
labels:=tstringlist.create;
for i:=0 to 200 do param[i]:=tvaripar.create;
mem1.filter:='Squences (*.seq)|*.seq|textes (*.txt)|*.txt';
mem1.defaultext:='.seq';
mem1.directory:=repseq;
{*********  Debut des dclaration propre  PILOTAGE}
{$IFDEF PILOTAGE }
{variables de comptage}
addvariable('Voltage1',0,0,0,0,'',tobject(@rien));
addvariable('Nup',0,0,0,0,'',tobject(@rien));
addvariable('Ndo',0,0,0,0,'',tobject(@rien));
addvariable('Mup',0,0,0,0,'',tobject(@rien));
addvariable('Mdo',0,0,0,0,'',tobject(@rien));
addvariable('integrale',0,0,0,0,'',tobject(@rien));
if suiviPRISMForm<>nil then begin
addvariable('Nupup',0,0,0,0,'',tobject(@rien));
addvariable('Nupdo',1,0,0,0,'',tobject(@rien));
addvariable('Ndoup',2,0,0,0,'',tobject(@rien));
addvariable('Ndodo',3,0,0,0,'',tobject(@rien));
addvariable('Mupup',0,0,0,0,'',tobject(@rien));
addvariable('Mupdo',1,0,0,0,'',tobject(@rien));
addvariable('Mdoup',2,0,0,0,'',tobject(@rien));
addvariable('Mdodo',3,0,0,0,'',tobject(@rien));
addvariable('Tupup',0,0,0,0,'',tobject(@rien));
addvariable('Tupdo',1,0,0,0,'',tobject(@rien));
addvariable('Tdoup',2,0,0,0,'',tobject(@rien));
addvariable('Tdodo',3,0,0,0,'',tobject(@rien));
addvariable('up',4,0,0,0,'',tobject(@rien));
addvariable('do',5,0,0,0,'',tobject(@rien));
addvariable('temps',4,0,0,0,'',tobject(@fixtemps));
addvariable('Tu1',1,0,0,0,'',tobject(@comptcond));
addvariable('Tu2',2,0,0,0,'',tobject(@comptcond));
addvariable('Tu3',3,0,0,0,'',tobject(@comptcond));
addvariable('Tu4',4,0,0,0,'',tobject(@comptcond));
addvariable('Cl1',5,0,0,0,'',tobject(@comptcond));
addvariable('Cl2',6,0,0,0,'',tobject(@comptcond));
addvariable('Cl3',7,0,0,0,'',tobject(@comptcond));
addvariable('Cl4',8,0,0,0,'',tobject(@comptcond));
end;
{variables RMN}
if pilotageRMNForm<>nil then begin
addvariable('Polar',0,0,0,0,'',tobject(@rien));
addvariable('temps',0,0,0,0,'',tobject(@rien));
end;
{variables acquisition 2D}
if comptage2Dform<>nil then begin
addvariable('acq2D',0,0,0,0,'',tobject(@rien));
end;
{variables internes}
addvariable('timer',100,1,0,0,'',tobject(@fixtimer));
{ajout des moteurs}
tablemot.open;
if tabmot<>nil then addmotorlist;
{l'ensemble des fonctions se rajoutent dans les fonctions possibles ici}
ordre.addobject('acqsimple',tobject(@acqsimple));
ordre.addobject('acqsimplePSD',tobject(@acqsimplePSD));
ordre.addobject('acqsimple2D',tobject(@acqsimple2D));
ordre.addobject('StartPolAlt',tobject(@StartPolAlt));
ordre.addobject('testacqsimple2D',tobject(@testacqsimple2D));
ordre.addobject('initTOF',tobject(@initTOF));
ordre.addobject('rebootTOF',tobject(@rebootTOF));
ordre.addobject('startTOF',tobject(@startTOF));
ordre.addobject('readdataTOF',tobject(@readdataTOF));
ordre.addobject('waitchamp',tobject(@waitchamp));    
ordre.addobject('waittemp',tobject(@waittemp));
ordre.addobject('waitmotors',tobject(@waitmotors));
ordre.addobject('pause',tobject(@pause));
ordre.addobject('addconditions',tobject(@addcond));
ordre.addobject('addangles',tobject(@addangles));
ordre.addobject('polarisation',tobject(@polarisation));
ordre.addobject('typecompt',tobject(@typcompt));
ordre.addobject('flippers',tobject(@fixflip));
ordre.addobject('setcurrent',tobject(@SetCurrent));
ordre.addobject('getvoltage',tobject(@GetVoltage));
ordre.addobject('WiltronON',tobject(@WiltronON));
ordre.addobject('WiltronOFF',tobject(@WiltronOFF));
ordre.addobject('RMNirrad',tobject(@RMNirrad));
ordre.addobject('RMNsaturation',tobject(@RMNsaturation));
ordre.addobject('RMNlitpolar',tobject(@RMNlitpolar));
ordre.addobject('RMNavecBase',tobject(@RMNavecBase));
ordre.addobject('addpol',tobject(@addpol));
ordre.addobject('clearvisupol',tobject(@clearvisupol));

ordre.addobject('setFieldL',tobject(@setFieldL));
ordre.addobject('setCurrentF1H',tobject(@setCurrentF1H));
ordre.addobject('setCurrentF1V',tobject(@setCurrentF1V));
ordre.addobject('setCurrentF2H',tobject(@setCurrentF2H));
ordre.addobject('setCurrentF2V',tobject(@setCurrentF2V));
ordre.addobject('init_BOSS508',tobject(@Init_BOSS508));
ordre.addobject('SetAsCurrentSource_BOSS508',tobject(@SetAsCurrentSource_BOSS508));
ordre.addobject('SetAsVoltageSource_BOSS508',tobject(@SetAsVoltageSource_BOSS508));
ordre.addobject('setCurrentBoss',tobject(@SetCurrentBoss));
ordre.addobject('setVoltageBoss',tobject(@SetVoltageBoss));
ordre.addobject('SetTime',tobject(@SetTime));
ordre.addobject('SetPolarisationType',tobject(@SetPolarisationType));
ordre.addobject('SetVout',tobject(@SetVout));

{$ENDIF }
{*********  Fin des dclaration propre  PILOTAGE}
ordre.addobject('addpt',tobject(@addpt));
ordre.addobject('addcomment',tobject(@addcomment));
ordre.addobject('delay',tobject(@delay));
ordre.addobject('clearspectre',tobject(@clearspectre));
ordre.addobject('addspectre',tobject(@addspectre));
{ manipulations des spectres de data }
{ fonctions agissant sur les spectres 1D }
ordre.addobject('delSpectre1D',tobject(@delSpectre1D));
ordre.addobject('addSpectre1D',tobject(@addSpectre1D));
ordre.addobject('subSpectre1D',tobject(@subSpectre1D));
ordre.addobject('multSpectre1D',tobject(@multSpectre1D));
ordre.addobject('divSpectre1D',tobject(@divSpectre1D));
ordre.addobject('scalAddSpectre1D',tobject(@ScalAddSpectre1D));
ordre.addobject('scalSubSpectre1D',tobject(@ScalSubSpectre1D));
ordre.addobject('scalMultSpectre1D',tobject(@ScalMultSpectre1D));
ordre.addobject('scalDivSpectre1D',tobject(@ScalDivSpectre1D));
{ aliases }
ordre.addobject('del1D',tobject(@delSpectre1D));
ordre.addobject('add1D',tobject(@addSpectre1D));
ordre.addobject('sub1D',tobject(@subSpectre1D));
ordre.addobject('mult1D',tobject(@multSpectre1D));
ordre.addobject('div1D',tobject(@divSpectre1D));
ordre.addobject('scalAdd1D',tobject(@ScalAddSpectre1D));
ordre.addobject('scalSub1D',tobject(@ScalSubSpectre1D));
ordre.addobject('scalMult1D',tobject(@ScalMultSpectre1D));
ordre.addobject('scalDiv1D',tobject(@ScalDivSpectre1D));
{ fonctions agissant sur les spectres 2D }
ordre.addobject('delSpectre2D',tobject(@delSpectre2D));
ordre.addobject('addSpectre2D',tobject(@addSpectre2D));
ordre.addobject('subSpectre2D',tobject(@subSpectre2D));
ordre.addobject('multSpectre2D',tobject(@multSpectre2D));
ordre.addobject('divSpectre2D',tobject(@divSpectre2D));
ordre.addobject('scalAddSpectre2D',tobject(@ScalAddSpectre2D));
ordre.addobject('scalSubSpectre2D',tobject(@ScalSubSpectre2D));
ordre.addobject('scalMultSpectre2D',tobject(@ScalMultSpectre2D));
ordre.addobject('scalDivSpectre2D',tobject(@ScalDivSpectre2D));
ordre.addobject('NormMoniSpectre2D',tobject(@NormMoniSpectre2D));
{ aliases }
ordre.addobject('del2D',tobject(@delSpectre2D));
ordre.addobject('add2D',tobject(@addSpectre2D));
ordre.addobject('sub2D',tobject(@subSpectre2D));
ordre.addobject('mult2D',tobject(@multSpectre2D));
ordre.addobject('div2D',tobject(@divSpectre2D));
ordre.addobject('scalAdd2D',tobject(@ScalAddSpectre2D));
ordre.addobject('scalSub2D',tobject(@ScalSubSpectre2D));
ordre.addobject('scalMult2D',tobject(@ScalMultSpectre2D));
ordre.addobject('scalDiv2D',tobject(@ScalDivSpectre2D));
{ fonctions de projection }
ordre.addobject('ProjectionHSpectre2D',tobject(@ProjectionHSpectre2D));
ordre.addobject('ProjectionVSpectre2D',tobject(@ProjectionVSpectre2D));
ordre.addobject('IntegraleSpectre1D',tobject(@IntegraleSpectre1D));
ordre.addobject('IntegraleSpectre2D',tobject(@IntegraleSpectre2D));
ordre.addobject('SommeCirculaireSpectre2D',tobject(@SommeCirculaireSpectre2D));
ordre.addobject('SommeDNPA',tobject(@SommeDNPA));
ordre.addobject('MasqueSecteur',tobject(@MasqueSecteur));
ordre.addobject('Barycentre2D',tobject(@Barycentre2D));   
{fonctions de gestion du tableau des conditions exprimentalles et commentaire}
ordre.addobject('SetExpCond',tobject(@SetExpCond));
ordre.addobject('SetComment',tobject(@SetComment));
ordre.addobject('Setstring',tobject(@Setstring));
ordre.addobject('Settab',tobject(@Settab));
{ fonctions de lecture de spectres }
ordre.addobject('readspectre2D',tobject(@readspectre2D));
ordre.addobject('lectureFichierHADAS',tobject(@lectureFichierHADAS));
ordre.addobject('openspectre',tobject(@openspectre));
ordre.addobject('SaveSpectre',tobject(@SaveSpectre));
{ fonction de concatnation de spectres 1D }
ordre.addobject('concat1D',tobject(@concat1D));
{ procdures  amliorer ET/OU finir }
ordre.addobject('saveToASCII1D',tobject(@saveToASCII1D));
ordre.addobject('saveToASCII2D',tobject(@saveToASCII2D));
{ ====================================== }
ordre.addobject('setX2D',tobject(@setX2D));
ordre.addobject('setY2D',tobject(@setY2D));
ordre.addobject('remap2DtoQxQz',tobject(@Remap2DtoQxQz));
{fonctions sur spectres 3D}
ordre.addobject('del3D',tobject(@delSpectre3D));
ordre.addobject('IntegraleSpectre3D',tobject(@IntegraleSpectre3D));
ordre.addobject('ReadMoni3D',tobject(@ReadMoni3D));
ordre.addobject('add3D',tobject(@addSpectre3D));
ordre.addobject('Spectre3DTo2D',tobject(@Spectre3DTo2D));

{ cration des labels de "la"  "lb" }
for i:=1 to 26 do
begin labels.add('L'+chr(i+64));labelstab[i]:=0;end;
flagwaitchamp:=false;
flagwaittemp:=false;
flagwaitacquis:=false;
flagwaitacquisPSD:=false;
flagwaitmotor:=false;
top:=350;
left:=600;
width:=380;
height:=350;
end;

procedure Tinterpreteurform.addmotorlist;
begin
{$IFDEF PILOTAGE }
tablemot.first;
while not tablemot.eof do begin
addvariable(tablemotnomcourt.value,0,tablemotindex.value,3,0,'',tobject(@settable));
addvariable(tablemotnomcourt.value+'dep',tablemotdepart.value,tablemotindex.value,4,0,'',tobject(@settable));
addvariable(tablemotnomcourt.value+'fin',tablemotfin.value,tablemotindex.value,5,0,'',tobject(@settable));
addvariable(tablemotnomcourt.value+'inc',tablemotinc.value,tablemotindex.value,6,0,'',tobject(@settable));
addvariable(tablemotnomcourt.value+'zero',tablemotzero.value,tablemotindex.value,7,0,'',tobject(@settable));
addvariable(tablemotnomcourt.value+'val',0,tablemotindex.value,8,0,'',tobject(@settable));
tablemot.next;
end;
{$ENDIF }
end;

{ cration d'une nouvelle variable }
procedure Tinterpreteurform.addvariable(name:string;value:integer;p1:integer;p2:double;p3:double;p4:string;tpro:tobject);
var
i:integer;
begin
parser1.setvariable(name,value);
i:=variable.AddObject(name,tpro);
param[i].p1:=p1;param[i].p2:=p2;param[i].p3:=p3;param[i].p4:=p4;
varpar.AddObject(name,@param[i]);
end;


procedure Tinterpreteurform.setvaleur(name:string;value:integer);
begin
parser1.setvariable(name,value);
end;

{ lancement d'une squence de script
{ INPUT: utilise le text du memo en cours }
procedure Tinterpreteurform.ScriptExecuteButtonClick(Sender: TObject);
begin
actligf.text:=mem1.memo.text;
pretraitement;
execution;
end;

procedure Tinterpreteurform.ScriptExecuteSelectionButtonClick(Sender: TObject);
begin
actligf.text:=mem1.memo.seltext;
pretraitement;
execution;
end;

{prtraitement traite les inclusions}
procedure Tinterpreteurform.pretraitement;
var
i,tf:integer;
fich:tstringlist;
s:string;
begin
for i:=1 to 26 do labelstab[i]:=0;
actlig.clear;
fich:=tstringlist.create;
tf:=1;
{ajout des inclusions}
while tf<>0 do begin
tf:=0;
for i:=0 to actligf.count-1 do begin
{ajout du ; oubli}
if pos(';',actligf.strings[i])<=0 then actligf.strings[i]:=actligf.strings[i]+';';
actligf.strings[i]:=copy(actligf.strings[i],1,pos(';',actligf.strings[i]));
if copy(actligf.strings[i],1,4)<>'inc=' then begin
actlig.add(actligf.strings[i]);
end else begin
filename:=copy(actligf.strings[i],5,pos(';',actligf.strings[i])-5);
fich.loadfromfile(repseq+filename+seqext);
actlig.addstrings(fich);
tf:=1;
end;
end;
if tf<>0 then begin
actligf.text:=actlig.text;
actlig.clear;
end;
end;
{fin d'ajout des inclusions}
{assignation des labels}
for i:=0 to actlig.count-1 do begin
s:=actlig.Strings[i];
if (copy(s,3,1)=':') and (labels.indexof(copy(s,1,2))>=0) then
labelstab[labels.indexof(copy(s,1,2))]:=i;
end;
fich.free;
end;

procedure tinterpreteurform.execution {test d'une squence pour criture};
begin
{dbut de la realisation}
seqlig:=0;
seqon:=1;
flagwaitacquis:=false;
flagwaitacquisPSD:=false;
flagwaitEnergizing:=false;
timer1.enabled:=true;
ScriptStatus.caption:='Running...';
end;


function Tinterpreteurform.traitstring(s:string;ind:integer):integer;
label
debut;
var
j:integer;
s2,sn,sval,nomvar:string;
retour:integer;
f:function(name:string):integer;
g:function:integer;
pari:string;
test,testu:boolean;
x,mon,tem:integer;
N,NU,ND,M,MU,MD,T,TU,TD:cardinal;
begin
{$IFDEF PILOTAGE }
{lecture de paramtres externes avant l'excution de l'instruction suivante}
{transfert des chelles de comptage}
suiviPRISMForm.getcomptage(1,x,mon,tem);
parser1.setvariable('Nupup',x);parser1.setvariable('Mupup',mon);
parser1.setvariable('Tupup',tem);
suiviPRISMForm.getcomptage(2,x,mon,tem);
parser1.setvariable('Ndodo',x);parser1.setvariable('Mdodo',mon);
parser1.setvariable('Tdodo',tem);
suiviPRISMForm.getcomptage(3,x,mon,tem);
parser1.setvariable('Nupdo',x);parser1.setvariable('Mupdo',mon);
parser1.setvariable('Tupdo',tem);
suiviPRISMForm.getcomptage(4,x,mon,tem);
parser1.setvariable('Ndoup',x);parser1.setvariable('Mdoup',mon);
parser1.setvariable('Tdoup',tem);

comptagePSD.getComptage(NU,ND,MU,MD);
parser1.setvariable('Nup',NU);parser1.setvariable('Mup',MU);
parser1.setvariable('Ndo',ND);parser1.setvariable('Mdo',MD);
parser1.setvariable('Integrale',integrale);
{$ENDIF }
retour:=ind+1;
debut:test:=false;
{chaine commentaire ou vide}
if (copy(s,1,1)=';') or (copy(s,2,1)=';') then test:=true;
{labels}
if (not test) and (copy(s,3,1)=':') and (labels.indexof(copy(s,1,2))>=0) then
s:=copy(s,4,length(s));
if (not test) and (copy(s,1,2)='if') then begin
{traitement du if}
 test:=true;
 if pos('then',s)<0 then
 begin
 timer1.enabled:=false;
 raise EvarError.Create('if sans then'+
 inttostr(ind)+':'+s);
 end;
 s2:=copy(s,4,pos('then',s)-5);
 testu:=false;
 if pos('>=',s2)>0 then begin
 sn:=copy(s2,1,pos('>=',s2)-1)+'-'+copy(s2,pos('>=',s2)+2,length(s2));
 parser1.expression:=sn;
 if parser1.value>=0 then testu:=true;
 end else
 if pos('<>',s2)>0 then begin
 sn:=copy(s2,1,pos('<>',s2)-1)+'-'+copy(s2,pos('<>',s2)+2,length(s2));
 parser1.expression:=sn;
 if parser1.value<>0 then testu:=true;
 end else
 if pos('<=',s2)>0 then begin
 sn:=copy(s2,1,pos('<=',s2)-1)+'-'+copy(s2,pos('<=',s2)+2,length(s2));
 parser1.expression:=sn;
 if parser1.value<=0 then testu:=true;
 end else
 if pos('=',s2)>0 then begin
 sn:=copy(s2,1,pos('=',s2)-1)+'-'+copy(s2,pos('=',s2)+1,length(s2));
 parser1.expression:=sn;
 if parser1.value=0 then testu:=true;
 end else
 if pos('<',s2)>0 then begin
 sn:=copy(s2,1,pos('<',s2)-1)+'-'+copy(s2,pos('<',s2)+1,length(s2));
 parser1.expression:=sn;
 if parser1.value<0 then testu:=true;
 end else
 if pos('>',s2)>0 then begin
 sn:=copy(s2,1,pos('>',s2)-1)+'-'+copy(s2,pos('>',s2)+1,length(s2));
 parser1.expression:=sn;
 if parser1.value>0 then testu:=true;
 end;
 if testu=true then begin
  s2:=copy(s,pos('then',s)+5,2);
  if labels.indexof(s2)>=0 then
  retour:=labelstab[labels.indexof(s2)] else
  begin
  s:=copy(s,pos('then',s)+5,length(s));goto debut;
  end;
 end;
end;
{fin du traitement if then}
if (not test) and (copy(s,1,4)='goto') then begin
s2:=copy(s,6,2);
  if labels.indexof(s2)>=0 then
  retour:=labelstab[labels.indexof(s2)];
test:=true;end;
{debut du traitement assignation de variables toto=10}
if (pos('=',s)>0) and not test then begin
test:=true;
sn:= copy(s,1,pos('=',s)-1);
if sn='' then raise  EvarError.Create('variable non valide  la ligne '+
inttostr(ind)+':'+s);
sval:=copy(s,pos('=',s)+1,pos(';',s)-pos('=',s)-1);
parser1.expression:=sval;
if not isvalidident(sn) then begin
timer1.enabled:=false;
raise  EvarError.Create('variable non valide  la ligne '+
inttostr(ind)+':'+s);
end else begin
try
if variable.indexof(sn)>=0 then begin
param[variable.indexof(sn)].value:=parser1.value;
@f:=variable.Objects[variable.indexof(sn)];
f(sn);
end;
parser1.setvariable(sn,parser1.value);
except begin
timer1.enabled:=false;
raise  EvarError.Create('variable non valide  la ligne '+
inttostr(ind)+':'+s);
end;
end;
end;
end;
{fin du traitement des variables}
{test des fonctions appeles}
if not test then begin
 if (pos('[',s)<=0) then
 begin
  pari:='';s2:=copy(s,1,pos(';',s)-1);
 end else begin
  s2:=copy(s,1,pos('[',s)-1);
  pari:=copy(s,pos('[',s)+1,pos(']',s)-pos('[',s)-1);    {pari = argument d'une instruction}
 end;
if ordre.indexof(s2)=-1 then
begin
timer1.enabled:=false;
raise EvarError.Create('fonction non valide  la ligne '+
inttostr(ind)+':'+s)
end else
begin {traitement des parametres}
 {clear}
 for j:=1 to 10 do
     begin
     pars[j]:='';
     par[j]:=0;
     end;
 j:=1;
 if pari<>'' then begin
  while (pos(',',pari)>0) and (j<=10) do
     begin {si il y a plus de 1 parametre}
     pars[j]:=copy(pari,1,pos(',',pari)-1); {pars[j] = chaine entre 1 et ,}
     if pos('"',pars[j])<=0 then
        {type variable ou expression}
        begin
        if  (pos('@',pars[j])=0) and (pos('$',pars[j])=0) and (pos('#',pars[j])=0) then
         begin {type expression numerique}
         parser1.expression:=copy(pari,1,pos(',',pari)-1);   {type variable}
         par[j]:=parser1.value;
         pars[j]:=floattostr(par[j]);
         end;
        if pos('$',pars[j])>1 then
         begin {type variable string: nom$}
         nomvar:=copy(pars[j],1,pos('$',pars[j])-1);
         if variable.indexof(nomvar) <>-1 then
            pars[j]:=param[variable.indexof(nomvar)].p4;
         end;
        if pos('@',pars[j])=1 then
         begin {type adresse variable: @nom}
         nomvar:=copy(pars[j],2,length(pars[j]));
         pars[j]:=nomvar;
         if variable.indexof(nomvar)=-1 then addvariable(pars[1],0,0,0,0,'',tobject(@rien));
         end;
        if pos('#',pars[j])>1 then
         begin {type variable tableau: nom#indice}
         nomvar:=copy(pars[j],1,pos('#',pars[j])-1);
         parser1.expression:=copy(pars[j],pos('#',pars[j])+1,length(pars[j]));
         if variable.indexof(nomvar) <>-1 then
            begin
            par[j]:=param[variable.indexof(nomvar)].p5[round(parser1.value)];
            pars[j]:=floattostr(par[j]);
            end;
         end;
        end
     else
        {type string}
        pars[j]:=copy(pars[j],2,length(pars[j])-2);

     {parametre suivant}
     pari:=copy(pari,pos(',',pari)+1,length(pari));
     j:=j+1;
     end;

  {traitement du dernier parametre}
  pars[j]:=pari;
  if pos('"',pars[j])<=0 then
     {type variable ou expression}
        begin
        if  (pos('@',pars[j])=0) and (pos('$',pars[j])=0) and (pos('#',pars[j])=0) then
         begin {type expression numerique}
         parser1.expression:=pari;   {type variable}
         par[j]:=parser1.value;
         pars[j]:=floattostr(par[j]);
         end;
        if pos('$',pars[j])>1 then
         begin {type variable string: nom$}
         nomvar:=copy(pars[j],1,pos('$',pars[j])-1);
         if variable.indexof(nomvar) <>-1 then
            pars[j]:=param[variable.indexof(nomvar)].p4;
         end;
        if pos('@',pars[j])=1 then
         begin {type adresse variable: @nom}
         nomvar:=copy(pars[j],2,length(pars[j]));
         pars[j]:=nomvar;
         if variable.indexof(nomvar)=-1 then addvariable(pars[1],0,0,0,0,'',tobject(@rien));
         end;
        if pos('#',pars[j])>1 then
         begin {type variable tableau: nom#indice}
         nomvar:=copy(pars[j],1,pos('#',pars[j])-1);
         parser1.expression:=copy(pars[j],pos('#',pars[j])+1,length(pars[j]));
         if variable.indexof(nomvar) <>-1 then
            begin
            par[j]:=param[variable.indexof(nomvar)].p5[round(parser1.value)];
            pars[j]:=floattostr(par[j]);
            end;
         end;
        end
  else
     {type string}
     pars[j]:=copy(pars[j],2,length(pars[j])-2);

 end;
 @g:=ordre.Objects[ordre.indexof(s2)];
 g;
end;
end;
result:=retour;
end;


procedure Tinterpreteurform.FormClose(Sender: TObject; var Action: TCloseAction);
var
i:integer;
begin
actlig.free;
actligf.free;
variable.free;
varpar.free;
ordre.free;
for i:=1 to 200 do param[i].free;
end;

procedure Tinterpreteurform.Timer1Timer(Sender: TObject);
begin
{$IFDEF PILOTAGE }
if (flagwaitmotor) and (tabmot<>nil) then flagwaitmotor:=tabmot.onmov;
if (flagwaitacquis) and (suiviPRISMForm<>nil) then flagwaitacquis:=suiviPRISMForm.testacquis;
if (flagwaitacquis) and (comptage2DForm<>nil) then flagwaitacquis:=comptage2DForm.testacquis;
if (flagwaitacquis) and (comptage2DTOFForm<>nil) then flagwaitacquis:=comptage2DTOFForm.testacquis;
if (flagwaitacquisPSD) and (ComptagePSD<>nil) then flagwaitacquisPSD:=comptagePSD.testacquis;
if (flagwaitEnergizing) then flagwaitEnergizing:=testEnergizing;
{$ENDIF }

if (seqon>0)
and (not flagwaitchamp)
and (not flagwaitmotor)
and (not flagwaitacquis)
and (not flagwaitacquisPSD)
and (not flagwaitEnergizing)
then begin
 if (seqlig<actlig.count) and (seqlig>=0) then begin
 while ((copy(actlig.strings[seqlig],1,1)=';') or
 (copy(actlig.strings[seqlig],2,1)=';'))
  and (seqlig<actlig.count-1) do seqlig:=seqlig+1;
  interpreteurform.caption:='sq : '+actlig.strings[seqlig];
  seqlig:=traitstring(actlig.strings[seqlig],seqlig);
  SuiviDesVariablesForm.affiche;
  end else begin
  seqon:=0;timer1.enabled:=false;
  interpreteurform.caption:='pas de squence en cours';
  scriptStatus.caption:='Paused';
 end;
end;
end;

procedure Tinterpreteurform.suividevariable1Click(Sender: TObject);
begin
if not SuiviDesVariablesForm.visible then SuiviDesVariablesForm.show
else SuiviDesVariablesForm.visible:=false;
end;

procedure Tinterpreteurform.ScriptStopButtonClick(Sender: TObject);
begin
{$IFDEF PILOTAGE }
if suiviPRISMForm<>nil then suiviPRISMForm.stop;  { arret du comptage dans PrismForm }
if comptage2DTOFform<>nil then comptage2DTOFform.stop; { arret du comptage dans comptage2DTOFform }
if comptage2Dform<>nil then comptage2Dform.stop;   { arret du comptage dans comptage2Dform }
{$ENDIF }
seqon:=0;timer1.enabled:=false;
interpreteurform.caption:='pas de squence en cours';
scriptStatus.caption:='Paused';
end;

procedure Tinterpreteurform.ContinueButtonClick(Sender: TObject); { a tester }
begin
     seqon:=1;timer1.enabled:=true;
end;

procedure Tinterpreteurform.variables1Click(Sender: TObject);
begin
if not VariablesListeForm.visible then
begin
VariablesListeForm.affiche;VariablesListeForm.show;
end else VariablesListeForm.visible:=false;
end;

procedure Tinterpreteurform.fonctions1Click(Sender: TObject);
begin
if not functionslisteform.visible then
begin
functionslisteform.affiche;functionslisteform.show;
end else functionslisteform.visible:=false;
end;

procedure Tinterpreteurform.Parser1ParserError(Sender: TObject; E: Exception);
var
mt:array[0..30] of char;
begin
timer1.enabled:=false;strpcopy(mt,E.message);
messagebox(interpreteurform.handle,'erreur',mt,mb_ok);
end;

procedure Tinterpreteurform.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
toto:integer;
begin
if key=13 then begin
toto:=1;
if pos(';',edit1.text)<=0 then edit1.text:=edit1.text+';';
traitstring(edit1.text,toto);
SuiviDesVariablesForm.affiche;
end;
end;

procedure Tinterpreteurform.executeseq(name:string);
begin
mem1.activepage:=10;
mem1.Memo.Lines.LoadfromFile(name);
{$IFDEF PILOTAGE }
if suiviPRISMForm<>nil then suiviPRISMForm.stop;
{$ENDIF }
timer1.enabled:=false;
actligf.text:=mem1.memo.text;
pretraitement;
execution;
end;
end.
