unit interfaceMoteurs;
{ pilotage des moteurs }
{ colonnes             }
{ 1, tablemotnom.text;
{ 3, tablemotbut.value;
{ 4, tablemotdepart.value;
{ 5, tablemotfin.value;
{ 6, tablemotinc.value;
{ 7, tablemotzero.value;  }
{ 8, position absolue
{ nangle: nombre de moteurs                          }
{ ACHTUNG, il y a du GPIB initialize dans cette procdure }
{ le 24.11.2000: FO ajout d'un boutton STOP a tester }
{ la procdure STOP reste a finir                    }
{ 29.01.01 : FO : on garde les difinitions par defaut de SetInoutEOS et OutPutEOS }
{                 les lignes correspondantes dans OnCreate sont supprimes     }
{                 ca bloque les moteurs !!!                                     }
{ 29.11.02 : FO : changement du but quand on fait un "set zero"                 }
{ ============================================================================= }
{ A NOTER }
{ function onmov est devenue "procedure" on remet function                      }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, DBTables, DB, ExtCtrls, EditData, GPIB_CEC, Grids, grilles;

const
     wm_writeangle=10020;  { ??? }

type
   moteurs=record
   nom:string;
   valeur:integer;
   but:integer;
   depart:integer;
   inc:integer;
   fin:integer;
   onmouv:boolean;
   addr:string[10];
   carte:integer;
   zero:integer;
   conva:double;
   convb:double;
   min:integer;
   max:integer;
   interf:integer;
   nomcourt:string;
end;

type
  Ttabmot = class(TForm)
    grille: tgrille;
    MainMenu1: TMainMenu;
    DataSource1: TDataSource;
    Tablemot: TTable;
    Timer1: TTimer;
    PopupMenu1: TPopupMenu;
    Panel1: TPanel;
    CommandBox: TEdit;
    STOP1: TButton;
    SendButton: TButton;
    ReceiveBox: TEdit;
    Movements1: TMenuItem;
    TablemotIndex: TIntegerField;
    TablemotNom: TStringField;
    TablemotZero: TIntegerField;
    TablemotDepart: TIntegerField;
    TablemotFin: TIntegerField;
    TablemotInc: TIntegerField;
    TablemotUnite: TStringField;
    TablemotConva: TFloatField;
    TablemotConvb: TFloatField;
    TablemotAutorisation: TIntegerField;
    TablemotAddrCarte: TIntegerField;
    TablemotAddrMoteur: TStringField;
    TablemotButeemin: TIntegerField;
    TablemotButeemax: TIntegerField;
    TablemotInterface: TIntegerField;
    TablemotNomcourt: TStringField;
    TablemotChaineinit: TStringField;
    TablemotValide: TIntegerField;
    TablemotValeur: TIntegerField;
    TablemotBut: TIntegerField;
    procedure OnCreate(Sender: TObject);
    procedure Editionmoteur1Click(Sender: TObject);
    procedure STOP1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure SendButtonClick(Sender: TObject);
    procedure grilleKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Dclarations prives }
  protected
    procedure mess(var msg:tmessage);message wm_oldselect;
    procedure wmwriteangle( var msg:tmessage); message wm_writeangle;
    procedure selection(var msg:tmessage);message wm_selection;
{    procedure changeColor(var msg:tmessage);message wm_onkeydown; }
  public
    scanon:integer;
    nangle:integer;
    { Dclarations publiques }
    function readangabs(ind:integer):longint;
    {lecture de l'angle cette fonction convertit la lecture de l'angle
    mais renvoie une valeur absolue}
    function readangrel(ind:integer):longint;
    {lecture de l'angle cette fonction convertit la lecture de l'angle
    mais renvoie une valeur relative (absolue-zero)}
    procedure resetang(ind:integer);{initialisation de l'angle}
    procedure resettout;{initialisation de l'angle}
    procedure movrel(ind:integer;value:longint);{lance un mouvement}
    procedure movabs(ind:integer;value:longint);{lance un mouvement absolu}
    function onmov:boolean;{teste si un mouvement est en cours}
    procedure stop;{stoppe les mouvements A FINIR !!!}
    procedure setzero(ind:integer;valeur:longint);{fixe le zro}
    procedure setnom;
    procedure setval(ind:integer;typ:integer;value:longint);{ecrit depart,fin,increment et zero}
    procedure lied;
    procedure ecritangles;
    { Dclarations publiques }
  end;

var
  tabmot: Ttabmot;
  mot:array[1..30] of moteurs;
implementation

uses editMoteursBase, setzerodialog, interpreteur, boitenoire;

{$R *.DFM}


procedure Ttabmot.mess(var msg:tmessage);
var
i,j,err:integer;
s:string;
begin
j:=msg.lparam;
if j<=nangle then begin
if msg.wparam=3 then begin
s:=grille.cells[3,j];
while pos(' ',s)<>0 do s:=copy(s,1,pos(' ',s)-1)+copy(s,pos(' ',s)+1,20);
val(s,i,err);
if err=0 then
movrel(j,i);
interpreteurform.setvaleur(mot[j].nomcourt,i);
end;
if msg.wparam=4 then begin
val(grille.cells[4,j],i,err);
mot[j].depart:=i;
interpreteurform.setvaleur(mot[j].nomcourt+'dep',i);
end;
if msg.wparam=5 then begin
val(grille.cells[5,j],i,err);
mot[j].fin:=i;
interpreteurform.setvaleur(mot[j].nomcourt+'fin',i);
end;
if msg.wparam=6 then begin
val(grille.cells[6,j],i,err);
mot[j].inc:=i;
interpreteurform.setvaleur(mot[j].nomcourt+'inc',i);
end;
end;
end;

{ rponse  un click sur une case du tableau des moteurs }
{ INPUT: msg, index de la colonne en cause               }
{ OUTPUT: msg = 7 => dlg pour la dfinition du zro      }
procedure Ttabmot.selection(var msg:tmessage);
var
j:integer;
s:string;
begin
j:=msg.lparam;
{ grille.cellColor[msg.wparam,msg.lparam]:=clRed;}
{ traitement de la dfinition du zro relatif }
if msg.wparam=7 then
   if (j>=1) and (j<=nangle)
      then begin
           {setzeromoteursDlg.expectedPosition.text:=inttostr(mot[j].zero+mot[j].but); }
           setzeromoteursDlg.expectedPosition.text:='0';
           setzeromoteursDlg.caption:='Ajustement du zro de l''angle '+mot[j].nom;
           if setzeromoteursDlg.showmodal=mrOK
              then begin
                   mot[j].zero:=mot[j].valeur-strtoint(setzeromoteursDlg.expectedPosition.text);
                   if tablemot.findkey([j])
                      then begin
                           if tablemot.state<>dsedit then tablemot.edit;
                           tablemotzero.value:=mot[j].zero;
                           tablemot.post;
                           end;
                   str(mot[j].zero,s);
                   grille.cells[7,j]:=s;
                   grille.cells[3,j]:=setzeromoteursDlg.expectedPosition.text;
                   end;
           end;
end;

{procedure Ttabmot.changeColor(var msg:tmessage);
begin
 grille.cellColor[msg.wparam,msg.lparam]:=clRed;
end; }

procedure Ttabmot.oncreate(Sender: TObject);
var
i,j:integer;
begin
tablemot.open;
gpibinitialize(21,0);
setoutputeos(13,0);
setinputeos(13);
settimeout(1000);
for i:=1 to 30 do mot[i].onmouv:=false;
tablemot.first;
nangle:=0;
while not tablemot.eof do begin
if tablemotindex.value>nangle then nangle:=tablemotindex.value;
tablemot.next;
end;
grille.coltype[1]:=13;grille.coltype[2]:=13;
grille.coltype[3]:=1;grille.coltype[4]:=1;grille.coltype[5]:=1;
grille.coltype[6]:=1;grille.coltype[7]:=14;grille.coltype[8]:=14;
grille.ColWidths[0] := 18;
grille.colwidths[1]:=90;grille.colwidths[2]:=44;
grille.colwidths[3]:=44;grille.colwidths[4]:=44;
grille.colwidths[5]:=45;grille.colwidths[6]:=33;
grille.colwidths[7]:=55;grille.colwidths[8]:=55;
grille.colcomment.add('essai');
grille.colcomment.add('essai2');
grille.cells[1,0]:='Angle';
grille.cells[2,0]:='Valeur';
grille.cells[3,0]:='But';
grille.cells[4,0]:='Dp';
grille.cells[5,0]:='Fin';
grille.cells[6,0]:='Inc';
grille.cells[7,0]:='Zero';
grille.cells[8,0]:='Abs';
setnom;
j:=0;
for i:=0 to grille.colcount-1 do j:=j+grille.colwidths[i];
width:=j+40;
grille.width:=j+35;
height:=180;
top:=520;
left:=0;
end;

{ lecture de la position de tous les moteurs }
{ INPUT: implictes                           }
{ OUTPUT: mise a jour de la position du moteur }
{         dans la grille et dans l'interprteur }
procedure Ttabmot.lied;
var
i:integer;
begin
for i:=1 to nangle do begin
mot[i].valeur:=readangabs(i);
grille.cells[2,i]:=inttostr(mot[i].valeur-mot[i].zero);
grille.cells[8,i]:=inttostr(mot[i].valeur);
interpreteurform.setvaleur(mot[i].nomcourt+'val',mot[i].valeur-mot[i].zero);
end;
end;

{ creation du tableau des moteurs  partir de la database }
procedure Ttabmot.setnom;
var
i:integer;
begin
grille.rowcount:=tablemot.RecordCount+1;
tablemot.first;
i:=0;
while not tablemot.eof do begin
grille.cells[1,tablemotindex.value]:=tablemotnom.text;
grille.cells[3,tablemotindex.value]:=inttostr(tablemotbut.value);
grille.cells[4,tablemotindex.value]:=inttostr(tablemotdepart.value);
grille.cells[5,tablemotindex.value]:=inttostr(tablemotfin.value);
grille.cells[6,tablemotindex.value]:=inttostr(tablemotinc.value);
grille.cells[7,tablemotindex.value]:=inttostr(tablemotzero.value);
mot[tablemotindex.value].valeur:=tablemotvaleur.value;
mot[tablemotindex.value].depart:=tablemotdepart.value;
mot[tablemotindex.value].fin:=tablemotfin.value;
mot[tablemotindex.value].inc:=tablemotinc.value;
mot[tablemotindex.value].zero:=tablemotzero.value;
mot[tablemotindex.value].but:=tablemotbut.value;
mot[tablemotindex.value].addr:=tablemotaddrmoteur.value;
mot[tablemotindex.value].carte:=tablemotaddrcarte.value;
mot[tablemotindex.value].conva:=tablemotconva.value;
mot[tablemotindex.value].convb:=tablemotconvb.value;
mot[tablemotindex.value].min:=tablemotbuteemin.value;
mot[tablemotindex.value].max:=tablemotbuteemax.value;
mot[tablemotindex.value].interf:=tablemotinterface.value;
mot[tablemotindex.value].nomcourt:=tablemotnomcourt.value;
mot[tablemotindex.value].nom:=tablemotnom.value;
tablemot.next;
i:=i+1;
end;
nangle:=i;
end;



procedure Ttabmot.Editionmoteur1Click(Sender: TObject);
begin
timer1.enabled:=false;
if (tablemot.state=dsedit) or (tablemot.state=dsinsert) then tablemot.post;
if (editmoteursbaseform.table1.state=dsedit) or (editmoteursbaseform.table1.state=dsinsert) then editmoteursbaseform.table1.post;
editmoteursbaseform.showmodal;
setnom;
timer1.enabled:=true;
end;

procedure Ttabmot.wmwriteangle( var msg:tmessage);
begin
{grille.cells[2,msg.wparam]:=inttostr(msg.lparam-tablemotzero.value);}
end;

procedure Ttabmot.STOP1Click(Sender: TObject);
var
i:integer;
begin
scanon:=0;
for i:=1 to 3 do grille.cellcolor[1,i]:=grille.font.color;
grille.refresh;
end;

{ mise a jour rgulire de la position affiche de tous les moteurs }
procedure Ttabmot.Timer1Timer(Sender: TObject);
begin
lied;
end;

{ lecture de la postion absolue d'un moteur }
{ INPUT: indice du mouvement                }
{ OUTPUT: la position du codeur             }
function Ttabmot.readangabs(ind:integer):longint;
var
value:extended;
s:string;
err:integer;
begin
if (ind>=1) and (ind<=nangle) then begin
case mot[ind].interf of
0:begin
s:='A'+mot[ind].addr;
gpibsend(mot[ind].carte,s);
gpibread(mot[ind].carte,s,255);
val(s,value,err);
if err=0 then mot[ind].valeur:=round(value*mot[ind].conva) else
mot[ind].valeur:=mot[ind].but+mot[ind].zero;
result:=mot[ind].valeur;
end
else result:=0;
end;
end else result:=-1;
end;

{ lecture de la postion absolue d'un moteur }
{ INPUT: indice du mouvement                }
{ OUTPUT: la position du codeur - Offset    }
{         en cas de problme retour -1      }
function Ttabmot.readangrel(ind:integer):longint;
var
value:longint;
begin
value:=readangabs(ind);
if value=-1 then result:=-1 else result:=value+mot[ind].zero;
end;

{ initialisation du moteur avec une chaine   }
{ d'initialisation stocke dans la database  }
procedure Ttabmot.resetang(ind:integer);
begin
if tablemot.findkey([ind]) then
if tablemotautorisation.value=1 then begin
case mot[ind].interf of
0:begin
gpibsend(mot[ind].carte,'#'+mot[ind].addr);
gpibsend(mot[ind].carte,tablemotchaineinit.value);
end;
end;
end;
end;

{initialisation de l'angle}
procedure Ttabmot.resettout;
begin
tablemot.first; { ??? }
while not tablemot.eof do begin
case tablemotinterface.value of
0:begin
gpibsend(tablemotaddrcarte.value,'#'+tablemotaddrmoteur.value);
gpibsend(tablemotaddrcarte.value,tablemotchaineinit.value);
end;
end;
tablemot.next;
end;
end;

procedure Ttabmot.movabs(ind:integer;value:longint);{interface mouvement}
var
s:string;
begin
if (ind>=1) and (ind<=nangle) then
if (value/mot[ind].conva>=mot[ind].min) and (value/mot[ind].conva<=mot[ind].max) then begin
case mot[ind].interf of
0:begin
 str(round(value/mot[ind].conva),s);
gpibsend(mot[ind].carte,'G'+mot[ind].addr+','+s);
  mot[ind].but:=value-mot[ind].zero;
  grille.cells[3,ind]:=inttostr(mot[ind].but);
  mot[ind].onmouv:=true;
 if mot[ind].carte=10 then gpibread(mot[ind].carte,s,255);
end;
end;
end;
end;

procedure Ttabmot.movrel(ind:integer;value:longint);{interface mouvement}
begin
if (ind>=1) and (ind<=nangle) then
movabs(ind,value+mot[ind].zero);
end;

function Ttabmot.onmov:boolean;
var
tf:integer;
i:integer;
s:string;
begin
tf:=0;
for i:=1 to nangle do
if mot[i].onmouv then
case mot[i].interf of
0:begin
s:='F'; gpibsend(mot[i].carte,s);gpibread(mot[i].carte,s,255);
if s='00' then begin tf:=tf+1 end else begin
mot[i].onmouv:=false;end;
end;
end;
if tf=0 then result:=false else result:=true;
end;

Procedure Ttabmot.stop;
begin
{ A COMPLETER }
end;

{ definition de l'offset d'un mouvement }
{ INPUT: indice du moteur, offset       }
{ OUTPUT: grille, tableMoteur et interpreteur MAJ     }
procedure Ttabmot.setzero(ind:integer;valeur:longint);{fixe le zro}
begin
if (ind>=1) and (ind<=nangle) then begin
mot[ind].zero:=valeur;
grille.cells[7,ind]:=inttostr(mot[ind].zero);
interpreteurform.setvaleur(mot[ind].nomcourt+'zero',mot[ind].zero);
end;
end;

procedure Ttabmot.setval(ind:integer;typ:integer;value:longint);{ecrit depart,fin,increment et zero}
begin
if (ind>=1) and (ind<=nangle) then begin
if (typ>=4) and (typ<=7) then begin
grille.cells[typ,ind]:=inttostr(value);
case typ of
4:mot[ind].depart:=value;
5:mot[ind].fin:=value;
6:mot[ind].inc:=value;
7:mot[ind].zero:=value;
end;
end;
if typ=3 then movrel(ind,value);
end;
end;

{ sortie de la grille Moteurs angles dans la boite noire }
procedure Ttabmot.ecritangles;
var
i:integer;
s:string;
begin
for i:=1 to nangle do begin
s:=mot[i].nomcourt+chr(9)+inttostr(mot[i].valeur-mot[i].zero)
   +chr(9)+inttostr(mot[i].zero)+chr(9)+inttostr(mot[i].valeur);
boitnoir.receivetext(s);
end;
end;

procedure Ttabmot.SendButtonClick(Sender: TObject);
var s:string;
begin
    gpibsend(10,CommandBox.text);
    gpibread(10,s,255);
    receiveBox.text:=s;
end;

procedure Ttabmot.grilleKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key=13
  then ;
end;

end.
